import { createFeatureSelector, createSelector, StoreModule } from '@ngrx/store';
import { Injectable, ɵɵdefineInjectable, NgModule } from '@angular/core';
import { ofType, Actions, Effect, EffectsModule } from '@ngrx/effects';
import { AngularFireAuth, AngularFireAuthModule } from '@angular/fire/auth';
import { __decorate, __metadata, __awaiter } from 'tslib';
import { map, exhaustMap, take, switchMap, catchError, tap, mapTo } from 'rxjs/operators';
import { zip, from, of, Observable } from 'rxjs';
import { auth } from 'firebase/app';
import 'firebase/auth';
import { AngularFireModule } from '@angular/fire';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function IUser() { }
if (false) {
    /** @type {?|undefined} */
    IUser.prototype.uid;
    /** @type {?} */
    IUser.prototype.displayName;
    /** @type {?} */
    IUser.prototype.email;
    /** @type {?|undefined} */
    IUser.prototype.photoURL;
    /** @type {?} */
    IUser.prototype.phoneNumber;
    /** @type {?|undefined} */
    IUser.prototype.emailVerified;
}
class User {
    /**
     * @param {?} uid
     * @param {?} displayName
     * @param {?} email
     * @param {?} phoneNumber
     * @param {?=} photoURL
     * @param {?=} emailVerified
     */
    constructor(uid, displayName, email, phoneNumber, photoURL, emailVerified) {
        this.uid = uid;
        this.displayName = displayName;
        this.email = email;
        this.phoneNumber = phoneNumber;
        this.photoURL = photoURL;
        this.emailVerified = emailVerified;
    }
}
if (false) {
    /** @type {?} */
    User.prototype.uid;
    /** @type {?} */
    User.prototype.displayName;
    /** @type {?} */
    User.prototype.email;
    /** @type {?} */
    User.prototype.phoneNumber;
    /** @type {?} */
    User.prototype.photoURL;
    /** @type {?} */
    User.prototype.emailVerified;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @enum {string} */
const CustomEmailHandlerActionTypes = {
    CheckActionCode: '[Auth/CustomEmailHandler] Check Action Code',
    CheckActionCodeError: '[Auth/CustomEmailHandler] Check Action Code Error',
    CheckActionCodeSuccess: '[Auth/CustomEmailHandler] Check Action Code Success',
    RecoverEmail: '[Auth/CustomEmailHandler] Recover Email',
    RecoverEmailSuccess: '[Auth/CustomEmailHandler] Recover Email Success',
    RecoverEmailError: '[Auth/CustomEmailHandler] Recover Email Error',
    ResetPassword: '[Auth/CustomEmailHandler] Reset Password',
    ResetPasswordSuccess: '[Auth/CustomEmailHandler] Reset Password Success',
    ResetPasswordError: '[Auth/CustomEmailHandler] Reset Password Error',
    VerifyEmailAddress: '[Auth/CustomEmailHandler] Verify Email Address',
    VerifyEmailAddressSuccess: '[Auth/CustomEmailHandler] Verify Email Address Success',
    VerifyEmailAddressError: '[Auth/CustomEmailHandler] Verify Email Address Error',
    VerifyPasswordResetCode: '[Auth/CustomEmailHandler] Verify Password Reset Code',
    VerifyPasswordResetCodeError: '[Auth/CustomEmailHandler] Verify Password Reset Error',
    VerifyPasswordResetCodeSuccess: '[Auth/CustomEmailHandler] Verify Password Reset Success',
};
class CheckActionCode {
    /**
     * @param {?} payload
     */
    constructor(payload) {
        this.payload = payload;
        this.type = CustomEmailHandlerActionTypes.CheckActionCode;
    }
}
if (false) {
    /** @type {?} */
    CheckActionCode.prototype.type;
    /** @type {?} */
    CheckActionCode.prototype.payload;
}
class CheckActionCodeError {
    /**
     * @param {?} payload
     */
    constructor(payload) {
        this.payload = payload;
        this.type = CustomEmailHandlerActionTypes.CheckActionCodeError;
    }
}
if (false) {
    /** @type {?} */
    CheckActionCodeError.prototype.type;
    /** @type {?} */
    CheckActionCodeError.prototype.payload;
}
class CheckActionCodeSuccess {
    /**
     * @param {?} payload
     */
    constructor(payload) {
        this.payload = payload;
        this.type = CustomEmailHandlerActionTypes.CheckActionCodeSuccess;
    }
}
if (false) {
    /** @type {?} */
    CheckActionCodeSuccess.prototype.type;
    /** @type {?} */
    CheckActionCodeSuccess.prototype.payload;
}
class RecoverEmail {
    /**
     * @param {?} payload
     */
    constructor(payload) {
        this.payload = payload;
        this.type = CustomEmailHandlerActionTypes.RecoverEmail;
    }
}
if (false) {
    /** @type {?} */
    RecoverEmail.prototype.type;
    /** @type {?} */
    RecoverEmail.prototype.payload;
}
class RecoverEmailError {
    /**
     * @param {?} payload
     */
    constructor(payload) {
        this.payload = payload;
        this.type = CustomEmailHandlerActionTypes.RecoverEmailError;
    }
}
if (false) {
    /** @type {?} */
    RecoverEmailError.prototype.type;
    /** @type {?} */
    RecoverEmailError.prototype.payload;
}
class RecoverEmailSuccess {
    constructor() {
        this.type = CustomEmailHandlerActionTypes.RecoverEmailSuccess;
    }
}
if (false) {
    /** @type {?} */
    RecoverEmailSuccess.prototype.type;
}
class ResetPassword {
    /**
     * @param {?} payload
     */
    constructor(payload) {
        this.payload = payload;
        this.type = CustomEmailHandlerActionTypes.ResetPassword;
    }
}
if (false) {
    /** @type {?} */
    ResetPassword.prototype.type;
    /** @type {?} */
    ResetPassword.prototype.payload;
}
class ResetPasswordError {
    /**
     * @param {?} payload
     */
    constructor(payload) {
        this.payload = payload;
        this.type = CustomEmailHandlerActionTypes.ResetPasswordError;
    }
}
if (false) {
    /** @type {?} */
    ResetPasswordError.prototype.type;
    /** @type {?} */
    ResetPasswordError.prototype.payload;
}
class ResetPasswordSuccess {
    constructor() {
        this.type = CustomEmailHandlerActionTypes.ResetPasswordSuccess;
    }
}
if (false) {
    /** @type {?} */
    ResetPasswordSuccess.prototype.type;
}
class VerifyEmailAddress {
    /**
     * @param {?} payload
     */
    constructor(payload) {
        this.payload = payload;
        this.type = CustomEmailHandlerActionTypes.VerifyEmailAddress;
    }
}
if (false) {
    /** @type {?} */
    VerifyEmailAddress.prototype.type;
    /** @type {?} */
    VerifyEmailAddress.prototype.payload;
}
class VerifyEmailAddressError {
    /**
     * @param {?} payload
     */
    constructor(payload) {
        this.payload = payload;
        this.type = CustomEmailHandlerActionTypes.VerifyEmailAddressError;
    }
}
if (false) {
    /** @type {?} */
    VerifyEmailAddressError.prototype.type;
    /** @type {?} */
    VerifyEmailAddressError.prototype.payload;
}
class VerifyEmailAddressSuccess {
    constructor() {
        this.type = CustomEmailHandlerActionTypes.VerifyEmailAddressSuccess;
    }
}
if (false) {
    /** @type {?} */
    VerifyEmailAddressSuccess.prototype.type;
}
class VerifyPasswordResetCode {
    /**
     * @param {?} payload
     */
    constructor(payload) {
        this.payload = payload;
        this.type = CustomEmailHandlerActionTypes.VerifyPasswordResetCode;
    }
}
if (false) {
    /** @type {?} */
    VerifyPasswordResetCode.prototype.type;
    /** @type {?} */
    VerifyPasswordResetCode.prototype.payload;
}
class VerifyPasswordResetCodeError {
    /**
     * @param {?} payload
     */
    constructor(payload) {
        this.payload = payload;
        this.type = CustomEmailHandlerActionTypes.VerifyPasswordResetCodeError;
    }
}
if (false) {
    /** @type {?} */
    VerifyPasswordResetCodeError.prototype.type;
    /** @type {?} */
    VerifyPasswordResetCodeError.prototype.payload;
}
class VerifyPasswordResetCodeSuccess {
    /**
     * @param {?} payload
     */
    constructor(payload) {
        this.payload = payload;
        this.type = CustomEmailHandlerActionTypes.VerifyPasswordResetCodeSuccess;
    }
}
if (false) {
    /** @type {?} */
    VerifyPasswordResetCodeSuccess.prototype.type;
    /** @type {?} */
    VerifyPasswordResetCodeSuccess.prototype.payload;
}

var customEmailHandler_actions = /*#__PURE__*/Object.freeze({
    CustomEmailHandlerActionTypes: CustomEmailHandlerActionTypes,
    CheckActionCode: CheckActionCode,
    CheckActionCodeError: CheckActionCodeError,
    CheckActionCodeSuccess: CheckActionCodeSuccess,
    RecoverEmail: RecoverEmail,
    RecoverEmailError: RecoverEmailError,
    RecoverEmailSuccess: RecoverEmailSuccess,
    ResetPassword: ResetPassword,
    ResetPasswordError: ResetPasswordError,
    ResetPasswordSuccess: ResetPasswordSuccess,
    VerifyEmailAddress: VerifyEmailAddress,
    VerifyEmailAddressError: VerifyEmailAddressError,
    VerifyEmailAddressSuccess: VerifyEmailAddressSuccess,
    VerifyPasswordResetCode: VerifyPasswordResetCode,
    VerifyPasswordResetCodeError: VerifyPasswordResetCodeError,
    VerifyPasswordResetCodeSuccess: VerifyPasswordResetCodeSuccess
});

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @enum {string} */
const PasswordManagementActionTypes = {
    ChangePasswordRequest: '[Auth/Password] Change Password Request',
    ChangePasswordError: '[Auth/Password] Change Password Error',
    ChangePasswordSuccess: '[Auth/Password] Change Password Success',
    ResetPasswordStatus: '[Auth/Password] Reset Change Password Status',
    ResetPasswordRequest: '[Auth/Password] Reset Password Request',
    ResetPasswordRequestError: '[Auth/Password] Reset Password Request Error',
    ResetPasswordRequestSuccess: '[Auth/Password] Reset Password Request Success',
};
class ChangePasswordRequest {
    /**
     * @param {?} payload
     */
    constructor(payload) {
        this.payload = payload;
        this.type = PasswordManagementActionTypes.ChangePasswordRequest;
    }
}
if (false) {
    /** @type {?} */
    ChangePasswordRequest.prototype.type;
    /** @type {?} */
    ChangePasswordRequest.prototype.payload;
}
class ChangePasswordError {
    /**
     * @param {?} payload
     */
    constructor(payload) {
        this.payload = payload;
        this.type = PasswordManagementActionTypes.ChangePasswordError;
    }
}
if (false) {
    /** @type {?} */
    ChangePasswordError.prototype.type;
    /** @type {?} */
    ChangePasswordError.prototype.payload;
}
class ChangePasswordSuccess {
    constructor() {
        this.type = PasswordManagementActionTypes.ChangePasswordSuccess;
    }
}
if (false) {
    /** @type {?} */
    ChangePasswordSuccess.prototype.type;
}
class ResetPasswordStatus {
    constructor() {
        this.type = PasswordManagementActionTypes.ResetPasswordStatus;
    }
}
if (false) {
    /** @type {?} */
    ResetPasswordStatus.prototype.type;
}
class ResetPasswordRequest {
    /**
     * @param {?} payload
     */
    constructor(payload) {
        this.payload = payload;
        this.type = PasswordManagementActionTypes.ResetPasswordRequest;
    }
}
if (false) {
    /** @type {?} */
    ResetPasswordRequest.prototype.type;
    /** @type {?} */
    ResetPasswordRequest.prototype.payload;
}
class ResetPasswordRequestError {
    /**
     * @param {?} payload
     */
    constructor(payload) {
        this.payload = payload;
        this.type = PasswordManagementActionTypes.ResetPasswordRequestError;
    }
}
if (false) {
    /** @type {?} */
    ResetPasswordRequestError.prototype.type;
    /** @type {?} */
    ResetPasswordRequestError.prototype.payload;
}
class ResetPasswordRequestSuccess {
    constructor() {
        this.type = PasswordManagementActionTypes.ResetPasswordRequestSuccess;
    }
}
if (false) {
    /** @type {?} */
    ResetPasswordRequestSuccess.prototype.type;
}

var passwordManagement_actions = /*#__PURE__*/Object.freeze({
    PasswordManagementActionTypes: PasswordManagementActionTypes,
    ChangePasswordRequest: ChangePasswordRequest,
    ChangePasswordError: ChangePasswordError,
    ChangePasswordSuccess: ChangePasswordSuccess,
    ResetPasswordStatus: ResetPasswordStatus,
    ResetPasswordRequest: ResetPasswordRequest,
    ResetPasswordRequestError: ResetPasswordRequestError,
    ResetPasswordRequestSuccess: ResetPasswordRequestSuccess
});

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @enum {string} */
const ProvidersManagementActionTypes = {
    CodeSent: '[Auth/Providers] Code Sent',
    LinkCredentialAccount: '[Auth/Providers] Link Credential Account',
    LinkFacebookAccount: '[Auth/Providers] Link Facebook Account',
    LinkGoogleAccount: '[Auth/Providers] Link Google Account',
    LinkError: '[Auth/Providers] Link Error',
    LinkSuccess: '[Auth/Providers] Link Success',
    SetProviders: '[Auth/Providers] Set Providers',
    UnlinkCredentialAccount: '[Auth/Providers] Unlink Credential Account',
    UnlinkFacebookAccount: '[Auth/Providers] Unlink Facebook Account',
    UnlinkGoogleAccount: '[Auth/Providers] Unlink Google Account',
    UnlinkError: '[Auth/Providers] Unlink Error',
    UnlinkSuccess: '[Auth/Providers] Unlink Success',
    SendPhoneNumberCode: '[Auth] Send Phone Number Code',
    UnlinkPhoneNumber: '[Auth] Unlink Phone Number',
    VerifyPhoneNumber: '[Auth] Verify Phone',
};
class LinkCredentialAccount {
    /**
     * @param {?} payload
     */
    constructor(payload) {
        this.payload = payload;
        this.type = ProvidersManagementActionTypes.LinkCredentialAccount;
    }
}
if (false) {
    /** @type {?} */
    LinkCredentialAccount.prototype.type;
    /** @type {?} */
    LinkCredentialAccount.prototype.payload;
}
class LinkFacebookAccount {
    constructor() {
        this.type = ProvidersManagementActionTypes.LinkFacebookAccount;
    }
}
if (false) {
    /** @type {?} */
    LinkFacebookAccount.prototype.type;
}
class LinkGoogleAccount {
    constructor() {
        this.type = ProvidersManagementActionTypes.LinkGoogleAccount;
    }
}
if (false) {
    /** @type {?} */
    LinkGoogleAccount.prototype.type;
}
class VerifyPhoneNumber {
    /**
     * @param {?} payload
     */
    constructor(payload) {
        this.payload = payload;
        this.type = ProvidersManagementActionTypes.VerifyPhoneNumber;
    }
}
if (false) {
    /** @type {?} */
    VerifyPhoneNumber.prototype.type;
    /** @type {?} */
    VerifyPhoneNumber.prototype.payload;
}
class LinkSuccess {
    /**
     * @param {?} payload
     */
    constructor(payload) {
        this.payload = payload;
        this.type = ProvidersManagementActionTypes.LinkSuccess;
    }
}
if (false) {
    /** @type {?} */
    LinkSuccess.prototype.type;
    /** @type {?} */
    LinkSuccess.prototype.payload;
}
class LinkError {
    /**
     * @param {?} payload
     */
    constructor(payload) {
        this.payload = payload;
        this.type = ProvidersManagementActionTypes.LinkError;
    }
}
if (false) {
    /** @type {?} */
    LinkError.prototype.type;
    /** @type {?} */
    LinkError.prototype.payload;
}
class UnlinkSuccess {
    /**
     * @param {?} payload
     */
    constructor(payload) {
        this.payload = payload;
        this.type = ProvidersManagementActionTypes.UnlinkSuccess;
    }
}
if (false) {
    /** @type {?} */
    UnlinkSuccess.prototype.type;
    /** @type {?} */
    UnlinkSuccess.prototype.payload;
}
class UnlinkError {
    /**
     * @param {?} payload
     */
    constructor(payload) {
        this.payload = payload;
        this.type = ProvidersManagementActionTypes.UnlinkError;
    }
}
if (false) {
    /** @type {?} */
    UnlinkError.prototype.type;
    /** @type {?} */
    UnlinkError.prototype.payload;
}
class SendPhoneNumberCode {
    /**
     * @param {?} payload
     */
    constructor(payload) {
        this.payload = payload;
        this.type = ProvidersManagementActionTypes.SendPhoneNumberCode;
    }
}
if (false) {
    /** @type {?} */
    SendPhoneNumberCode.prototype.type;
    /** @type {?} */
    SendPhoneNumberCode.prototype.payload;
}
class UnlinkFacebookAccount {
    constructor() {
        this.type = ProvidersManagementActionTypes.UnlinkFacebookAccount;
    }
}
if (false) {
    /** @type {?} */
    UnlinkFacebookAccount.prototype.type;
}
class UnlinkGoogleAccount {
    constructor() {
        this.type = ProvidersManagementActionTypes.UnlinkGoogleAccount;
    }
}
if (false) {
    /** @type {?} */
    UnlinkGoogleAccount.prototype.type;
}
class UnlinkCredentialAccount {
    constructor() {
        this.type = ProvidersManagementActionTypes.UnlinkCredentialAccount;
    }
}
if (false) {
    /** @type {?} */
    UnlinkCredentialAccount.prototype.type;
}
class SetProviders {
    /**
     * @param {?} payload
     */
    constructor(payload) {
        this.payload = payload;
        this.type = ProvidersManagementActionTypes.SetProviders;
    }
}
if (false) {
    /** @type {?} */
    SetProviders.prototype.type;
    /** @type {?} */
    SetProviders.prototype.payload;
}
class CodeSent {
    constructor() {
        this.type = ProvidersManagementActionTypes.CodeSent;
    }
}
if (false) {
    /** @type {?} */
    CodeSent.prototype.type;
}
class UnlinkPhoneNumber {
    constructor() {
        this.type = ProvidersManagementActionTypes.UnlinkPhoneNumber;
    }
}
if (false) {
    /** @type {?} */
    UnlinkPhoneNumber.prototype.type;
}

var providersManagement_actions = /*#__PURE__*/Object.freeze({
    ProvidersManagementActionTypes: ProvidersManagementActionTypes,
    LinkCredentialAccount: LinkCredentialAccount,
    LinkFacebookAccount: LinkFacebookAccount,
    LinkGoogleAccount: LinkGoogleAccount,
    VerifyPhoneNumber: VerifyPhoneNumber,
    LinkSuccess: LinkSuccess,
    LinkError: LinkError,
    UnlinkSuccess: UnlinkSuccess,
    UnlinkError: UnlinkError,
    SendPhoneNumberCode: SendPhoneNumberCode,
    UnlinkFacebookAccount: UnlinkFacebookAccount,
    UnlinkGoogleAccount: UnlinkGoogleAccount,
    UnlinkCredentialAccount: UnlinkCredentialAccount,
    SetProviders: SetProviders,
    CodeSent: CodeSent,
    UnlinkPhoneNumber: UnlinkPhoneNumber
});

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @enum {string} */
const AuthActionTypes = {
    Authenticated: '[Auth] Authenticated',
    AuthError: '[Auth] Error',
    CredentialsLogin: '[Auth] Credentials Login Attempt',
    CredentialsReAuthentication: '[Auth] Credentials ReAuthentication attempt',
    CredentialsRegistration: '[Auth] Credentials Registration Attempt',
    DeleteAccount: '[Auth] Delete Account',
    DeleteAccountSuccess: '[Auth] Delete Account Success',
    DeleteAccountError: '[Auth] Delete Account Error',
    FacebookLogin: '[Auth] Facebook Login Attempt',
    FacebookReAuthentication: '[Auth] Facebook ReAuthentication Attempt',
    FacebookRegistration: '[Auth] Facebook Registration Attempt',
    GetUser: '[Auth] Get User',
    GoogleLogin: '[Auth] Google Login Attempt',
    GoogleReAuthentication: '[Auth] Google ReAuthentication Attempt',
    GoogleRegistration: '[Auth] Google Registration Attempt',
    Logout: '[Auth] Logout',
    NotAuthenticated: '[Auth] Not Authenticated',
    SendVerificationEmail: '[Auth] Send Verification Email',
    ReAuthenticationError: '[Auth] ReAuthentication Error',
    ReAuthenticationSuccess: '[Auth] ReAuthentication Success',
    RefreshToken: '[Auth] ReFresh Token',
    RegistrationSuccess: '[Auth] Registration Success',
    ResetAuthState: '[Auth] Reset State',
    VerificationEmailError: '[Auth] Verification Email Error',
    VerificationEmailSent: '[Auth] Verification Email Sent',
};
class GetUser {
    /**
     * @param {?=} payload
     */
    constructor(payload) {
        this.payload = payload;
        this.type = AuthActionTypes.GetUser;
    }
}
if (false) {
    /** @type {?} */
    GetUser.prototype.type;
    /** @type {?} */
    GetUser.prototype.payload;
}
class Authenticated {
    /**
     * @param {?} payload
     */
    constructor(payload) {
        this.payload = payload;
        this.type = AuthActionTypes.Authenticated;
    }
}
if (false) {
    /** @type {?} */
    Authenticated.prototype.type;
    /** @type {?} */
    Authenticated.prototype.payload;
}
class NotAuthenticated {
    /**
     * @param {?=} payload
     */
    constructor(payload) {
        this.payload = payload;
        this.type = AuthActionTypes.NotAuthenticated;
    }
}
if (false) {
    /** @type {?} */
    NotAuthenticated.prototype.type;
    /** @type {?} */
    NotAuthenticated.prototype.payload;
}
class AuthError {
    /**
     * @param {?=} payload
     */
    constructor(payload) {
        this.payload = payload;
        this.type = AuthActionTypes.AuthError;
    }
}
if (false) {
    /** @type {?} */
    AuthError.prototype.type;
    /** @type {?} */
    AuthError.prototype.payload;
}
class GoogleRegistration {
    /**
     * @param {?=} payload
     */
    constructor(payload) {
        this.payload = payload;
        this.type = AuthActionTypes.GoogleRegistration;
    }
}
if (false) {
    /** @type {?} */
    GoogleRegistration.prototype.type;
    /** @type {?} */
    GoogleRegistration.prototype.payload;
}
class FacebookRegistration {
    /**
     * @param {?=} payload
     */
    constructor(payload) {
        this.payload = payload;
        this.type = AuthActionTypes.FacebookRegistration;
    }
}
if (false) {
    /** @type {?} */
    FacebookRegistration.prototype.type;
    /** @type {?} */
    FacebookRegistration.prototype.payload;
}
class CredentialsRegistration {
    /**
     * @param {?} payload
     */
    constructor(payload) {
        this.payload = payload;
        this.type = AuthActionTypes.CredentialsRegistration;
    }
}
if (false) {
    /** @type {?} */
    CredentialsRegistration.prototype.type;
    /** @type {?} */
    CredentialsRegistration.prototype.payload;
}
class RegistrationSuccess {
    /**
     * @param {?} payload
     */
    constructor(payload) {
        this.payload = payload;
        this.type = AuthActionTypes.RegistrationSuccess;
    }
}
if (false) {
    /** @type {?} */
    RegistrationSuccess.prototype.type;
    /** @type {?} */
    RegistrationSuccess.prototype.payload;
}
class Logout {
    /**
     * @param {?=} payload
     */
    constructor(payload) {
        this.payload = payload;
        this.type = AuthActionTypes.Logout;
    }
}
if (false) {
    /** @type {?} */
    Logout.prototype.type;
    /** @type {?} */
    Logout.prototype.payload;
}
class GoogleLogin {
    /**
     * @param {?=} payload
     */
    constructor(payload) {
        this.payload = payload;
        this.type = AuthActionTypes.GoogleLogin;
    }
}
if (false) {
    /** @type {?} */
    GoogleLogin.prototype.type;
    /** @type {?} */
    GoogleLogin.prototype.payload;
}
class FacebookLogin {
    /**
     * @param {?=} payload
     */
    constructor(payload) {
        this.payload = payload;
        this.type = AuthActionTypes.FacebookLogin;
    }
}
if (false) {
    /** @type {?} */
    FacebookLogin.prototype.type;
    /** @type {?} */
    FacebookLogin.prototype.payload;
}
class CredentialsLogin {
    /**
     * @param {?} email
     * @param {?} password
     * @param {?=} remember
     */
    constructor(email, password, remember) {
        this.email = email;
        this.password = password;
        this.remember = remember;
        this.type = AuthActionTypes.CredentialsLogin;
    }
}
if (false) {
    /** @type {?} */
    CredentialsLogin.prototype.type;
    /** @type {?} */
    CredentialsLogin.prototype.email;
    /** @type {?} */
    CredentialsLogin.prototype.password;
    /** @type {?} */
    CredentialsLogin.prototype.remember;
}
class GoogleReAuthentication {
    /**
     * @param {?=} payload
     */
    constructor(payload) {
        this.payload = payload;
        this.type = AuthActionTypes.GoogleReAuthentication;
    }
}
if (false) {
    /** @type {?} */
    GoogleReAuthentication.prototype.type;
    /** @type {?} */
    GoogleReAuthentication.prototype.payload;
}
class FacebookReAuthentication {
    /**
     * @param {?=} payload
     */
    constructor(payload) {
        this.payload = payload;
        this.type = AuthActionTypes.FacebookReAuthentication;
    }
}
if (false) {
    /** @type {?} */
    FacebookReAuthentication.prototype.type;
    /** @type {?} */
    FacebookReAuthentication.prototype.payload;
}
class CredentialsReAuthentication {
    /**
     * @param {?} email
     * @param {?} password
     * @param {?=} remember
     */
    constructor(email, password, remember) {
        this.email = email;
        this.password = password;
        this.remember = remember;
        this.type = AuthActionTypes.CredentialsReAuthentication;
    }
}
if (false) {
    /** @type {?} */
    CredentialsReAuthentication.prototype.type;
    /** @type {?} */
    CredentialsReAuthentication.prototype.email;
    /** @type {?} */
    CredentialsReAuthentication.prototype.password;
    /** @type {?} */
    CredentialsReAuthentication.prototype.remember;
}
class ReAuthenticationSuccess {
    constructor() {
        this.type = AuthActionTypes.ReAuthenticationSuccess;
    }
}
if (false) {
    /** @type {?} */
    ReAuthenticationSuccess.prototype.type;
}
class ReAuthenticationError {
    /**
     * @param {?=} payload
     */
    constructor(payload) {
        this.payload = payload;
        this.type = AuthActionTypes.ReAuthenticationError;
    }
}
if (false) {
    /** @type {?} */
    ReAuthenticationError.prototype.type;
    /** @type {?} */
    ReAuthenticationError.prototype.payload;
}
class SendVerificationEmail {
    /**
     * @param {?} payload
     */
    constructor(payload) {
        this.payload = payload;
        this.type = AuthActionTypes.SendVerificationEmail;
    }
}
if (false) {
    /** @type {?} */
    SendVerificationEmail.prototype.type;
    /** @type {?} */
    SendVerificationEmail.prototype.payload;
}
class VerificationEmailError {
    /**
     * @param {?} payload
     */
    constructor(payload) {
        this.payload = payload;
        this.type = AuthActionTypes.VerificationEmailError;
    }
}
if (false) {
    /** @type {?} */
    VerificationEmailError.prototype.type;
    /** @type {?} */
    VerificationEmailError.prototype.payload;
}
class VerificationEmailSent {
    constructor() {
        this.type = AuthActionTypes.VerificationEmailSent;
    }
}
if (false) {
    /** @type {?} */
    VerificationEmailSent.prototype.type;
}
class DeleteAccount {
    constructor() {
        this.type = AuthActionTypes.DeleteAccount;
    }
}
if (false) {
    /** @type {?} */
    DeleteAccount.prototype.type;
}
class DeleteAccountSuccess {
    constructor() {
        this.type = AuthActionTypes.DeleteAccountSuccess;
    }
}
if (false) {
    /** @type {?} */
    DeleteAccountSuccess.prototype.type;
}
class DeleteAccountError {
    /**
     * @param {?} payload
     */
    constructor(payload) {
        this.payload = payload;
        this.type = AuthActionTypes.DeleteAccountError;
    }
}
if (false) {
    /** @type {?} */
    DeleteAccountError.prototype.type;
    /** @type {?} */
    DeleteAccountError.prototype.payload;
}
class ResetAuthState {
    constructor() {
        this.type = AuthActionTypes.ResetAuthState;
    }
}
if (false) {
    /** @type {?} */
    ResetAuthState.prototype.type;
}
class RefreshToken {
    constructor() {
        this.type = AuthActionTypes.RefreshToken;
    }
}
if (false) {
    /** @type {?} */
    RefreshToken.prototype.type;
}

var auth_actions = /*#__PURE__*/Object.freeze({
    AuthActionTypes: AuthActionTypes,
    GetUser: GetUser,
    Authenticated: Authenticated,
    NotAuthenticated: NotAuthenticated,
    AuthError: AuthError,
    GoogleRegistration: GoogleRegistration,
    FacebookRegistration: FacebookRegistration,
    CredentialsRegistration: CredentialsRegistration,
    RegistrationSuccess: RegistrationSuccess,
    Logout: Logout,
    GoogleLogin: GoogleLogin,
    FacebookLogin: FacebookLogin,
    CredentialsLogin: CredentialsLogin,
    GoogleReAuthentication: GoogleReAuthentication,
    FacebookReAuthentication: FacebookReAuthentication,
    CredentialsReAuthentication: CredentialsReAuthentication,
    ReAuthenticationSuccess: ReAuthenticationSuccess,
    ReAuthenticationError: ReAuthenticationError,
    SendVerificationEmail: SendVerificationEmail,
    VerificationEmailError: VerificationEmailError,
    VerificationEmailSent: VerificationEmailSent,
    DeleteAccount: DeleteAccount,
    DeleteAccountSuccess: DeleteAccountSuccess,
    DeleteAccountError: DeleteAccountError,
    ResetAuthState: ResetAuthState,
    RefreshToken: RefreshToken
});

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function State() { }
if (false) {
    /** @type {?} */
    State.prototype.loggedIn;
    /** @type {?} */
    State.prototype.user;
    /** @type {?} */
    State.prototype.loading;
    /** @type {?} */
    State.prototype.error;
    /** @type {?} */
    State.prototype.success;
}
/** @type {?} */
const defaultState = {
    loggedIn: false,
    user: null,
    loading: true,
    error: null,
    success: false
};
/// Reducer function
/**
 * @param {?=} state
 * @param {?=} action
 * @return {?}
 */
function reducer(state = defaultState, action) {
    switch (action.type) {
        case AuthActionTypes.GetUser:
            return Object.assign({}, state, { loading: true, success: false });
        case AuthActionTypes.Authenticated:
        case AuthActionTypes.RegistrationSuccess:
            return Object.assign({}, state, { user: action.payload.user, loading: false, loggedIn: true, success: false });
        case AuthActionTypes.NotAuthenticated:
            return Object.assign({}, state, defaultState, { loading: false, loggedIn: false, success: false });
        case AuthActionTypes.GoogleLogin:
        case AuthActionTypes.FacebookLogin:
        case AuthActionTypes.GoogleRegistration:
        case AuthActionTypes.FacebookRegistration:
        case AuthActionTypes.CredentialsLogin:
        case AuthActionTypes.CredentialsRegistration:
        case AuthActionTypes.FacebookReAuthentication:
        case AuthActionTypes.CredentialsReAuthentication:
        case AuthActionTypes.GoogleReAuthentication:
            return Object.assign({}, state, { loading: true, success: false });
        case AuthActionTypes.ResetAuthState:
            return Object.assign({}, state, { loading: false, success: false, error: null });
        case AuthActionTypes.AuthError:
        case AuthActionTypes.ReAuthenticationError:
            return Object.assign({}, state, { loading: false, success: false, error: action.payload });
        case AuthActionTypes.ReAuthenticationSuccess:
            return Object.assign({}, state, { loading: false, error: null, success: true });
        case AuthActionTypes.Logout:
            return Object.assign({}, state, { loading: true });
        case AuthActionTypes.DeleteAccount:
            return Object.assign({}, state, { loading: true, success: true, error: null });
        case AuthActionTypes.DeleteAccountError:
            return Object.assign({}, state, { loading: false, success: false, error: action.payload });
        case AuthActionTypes.DeleteAccountSuccess:
            return Object.assign({}, state, { loading: false, loggedIn: false, success: true, error: null, user: null });
        case CustomEmailHandlerActionTypes.VerifyEmailAddressSuccess:
            return Object.assign({}, state, { user: Object.assign({}, state.user, { emailVerified: true }) });
        default:
            return state;
    }
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function State$1() { }
if (false) {
    /** @type {?} */
    State$1.prototype.loading;
    /** @type {?} */
    State$1.prototype.success;
    /** @type {?} */
    State$1.prototype.error;
}
/** @type {?} */
const initialState = (/** @type {?} */ ({
    loading: false,
    success: false,
    error: null
}));
/**
 * @param {?=} state
 * @param {?=} action
 * @return {?}
 */
function reducer$1(state = initialState, action) {
    switch (action.type) {
        case PasswordManagementActionTypes.ResetPasswordRequest:
        case PasswordManagementActionTypes.ChangePasswordRequest: {
            return Object.assign({}, state, { loading: true, success: false, error: null });
        }
        case PasswordManagementActionTypes.ResetPasswordRequestError:
        case PasswordManagementActionTypes.ChangePasswordError: {
            return Object.assign({}, state, { loading: false, success: false, error: action.payload });
        }
        case PasswordManagementActionTypes.ResetPasswordRequestSuccess:
        case PasswordManagementActionTypes.ChangePasswordSuccess: {
            return Object.assign({}, state, { loading: false, success: true, error: null });
        }
        case PasswordManagementActionTypes.ResetPasswordStatus: {
            return Object.assign({}, state, { loading: false, success: false, error: null });
        }
        default:
            return state;
    }
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function State$2() { }
if (false) {
    /** @type {?} */
    State$2.prototype.loading;
    /** @type {?} */
    State$2.prototype.success;
    /** @type {?} */
    State$2.prototype.providers;
    /** @type {?} */
    State$2.prototype.error;
}
/** @type {?} */
const initialState$1 = (/** @type {?} */ ({
    loading: false,
    success: false,
    providers: {
        facebook: false,
        google: false,
        phone: false,
        password: false
    },
    error: null
}));
/**
 * @param {?=} state
 * @param {?=} action
 * @return {?}
 */
function reducer$2(state = initialState$1, action) {
    switch (action.type) {
        case ProvidersManagementActionTypes.SetProviders:
            return Object.assign({}, state, { providers: Object.assign({}, state.providers, action.payload) });
        case ProvidersManagementActionTypes.LinkCredentialAccount:
        case ProvidersManagementActionTypes.LinkFacebookAccount:
        case ProvidersManagementActionTypes.LinkGoogleAccount:
        case ProvidersManagementActionTypes.UnlinkCredentialAccount:
        case ProvidersManagementActionTypes.UnlinkGoogleAccount:
        case ProvidersManagementActionTypes.UnlinkFacebookAccount:
            return Object.assign({}, state, { success: false, error: null, loading: true });
        case ProvidersManagementActionTypes.LinkSuccess:
            return Object.assign({}, state, { providers: Object.assign({}, state.providers, { [action.payload.provider]: true }), success: true, error: null, loading: false });
        case ProvidersManagementActionTypes.UnlinkSuccess:
            return Object.assign({}, state, { providers: Object.assign({}, state.providers, { [action.payload.provider]: false }), success: true, error: null, loading: false });
        case ProvidersManagementActionTypes.LinkError:
        case ProvidersManagementActionTypes.UnlinkError:
            return Object.assign({}, state, { success: false, error: action.payload, loading: false });
        default:
            return state;
    }
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
const initialRequestStatus = {
    loading: false,
    success: false,
    error: null
};
/**
 * @record
 */
function State$3() { }
if (false) {
    /** @type {?} */
    State$3.prototype.emailVerified;
    /** @type {?} */
    State$3.prototype.passwordResetCode;
    /** @type {?} */
    State$3.prototype.resetPassword;
    /** @type {?} */
    State$3.prototype.checkCode;
    /** @type {?} */
    State$3.prototype.recoverEmail;
}
/** @type {?} */
const initialState$2 = (/** @type {?} */ ({
    emailVerified: Object.assign({}, initialRequestStatus),
    passwordResetCode: Object.assign({}, initialRequestStatus),
    resetPassword: Object.assign({}, initialRequestStatus),
    checkCode: Object.assign({}, initialRequestStatus),
    recoverEmail: Object.assign({}, initialRequestStatus)
}));
/**
 * @param {?=} state
 * @param {?=} action
 * @return {?}
 */
function reducer$3(state = initialState$2, action) {
    switch (action.type) {
        case CustomEmailHandlerActionTypes.VerifyEmailAddress: {
            return Object.assign({}, state, { emailVerified: { loading: true, success: false, error: null } });
        }
        case CustomEmailHandlerActionTypes.VerifyEmailAddressError: {
            return Object.assign({}, state, { emailVerified: { loading: false, success: false, error: action.payload } });
        }
        case CustomEmailHandlerActionTypes.VerifyEmailAddressSuccess: {
            return Object.assign({}, state, { emailVerified: { loading: false, success: true, error: null } });
        }
        case CustomEmailHandlerActionTypes.VerifyPasswordResetCode: {
            return Object.assign({}, state, { passwordResetCode: { email: null, loading: true, success: false, error: null } });
        }
        case CustomEmailHandlerActionTypes.VerifyPasswordResetCodeError: {
            return Object.assign({}, state, { passwordResetCode: { email: null, loading: false, success: false, error: action.payload } });
        }
        case CustomEmailHandlerActionTypes.VerifyPasswordResetCodeSuccess: {
            return Object.assign({}, state, { passwordResetCode: { email: action.payload.email, loading: false, success: true, error: null } });
        }
        case CustomEmailHandlerActionTypes.CheckActionCode: {
            return Object.assign({}, state, { checkCode: { loading: true, success: false, error: null } });
        }
        case CustomEmailHandlerActionTypes.CheckActionCodeError: {
            return Object.assign({}, state, { checkCode: { loading: false, success: false, error: action.payload } });
        }
        case CustomEmailHandlerActionTypes.CheckActionCodeSuccess: {
            return Object.assign({}, state, { checkCode: { loading: false, success: true, error: null } });
        }
        case CustomEmailHandlerActionTypes.RecoverEmail: {
            return Object.assign({}, state, { recoverEmail: { loading: true, success: false, error: null } });
        }
        case CustomEmailHandlerActionTypes.RecoverEmailError: {
            return Object.assign({}, state, { recoverEmail: { loading: false, success: false, error: action.payload } });
        }
        case CustomEmailHandlerActionTypes.RecoverEmailSuccess: {
            return Object.assign({}, state, { recoverEmail: { loading: false, success: true, error: null } });
        }
        case CustomEmailHandlerActionTypes.ResetPassword: {
            return Object.assign({}, state, { resetPassword: { loading: true, success: false, error: null } });
        }
        case CustomEmailHandlerActionTypes.ResetPasswordError: {
            return Object.assign({}, state, { resetPassword: { loading: false, success: false, error: action.payload } });
        }
        case CustomEmailHandlerActionTypes.ResetPasswordSuccess: {
            return Object.assign({}, state, { resetPassword: { loading: false, success: true, error: null } });
        }
        default:
            return state;
    }
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function AuthState() { }
if (false) {
    /** @type {?} */
    AuthState.prototype.user;
    /** @type {?} */
    AuthState.prototype.changePassword;
    /** @type {?} */
    AuthState.prototype.providers;
    /** @type {?} */
    AuthState.prototype.customEmailHandler;
}
/** @type {?} */
const reducers = {
    user: reducer,
    changePassword: reducer$1,
    providers: reducer$2,
    customEmailHandler: reducer$3
};
/** @type {?} */
const getAuthState = createFeatureSelector('auth');
const ɵ0 = /**
 * @param {?} state
 * @return {?}
 */
state => state.user;
/** @type {?} */
const getUserState = createSelector(getAuthState, (ɵ0));
const ɵ1 = /**
 * @param {?} state
 * @return {?}
 */
state => state.user.loading;
/** @type {?} */
const isAuthLoading = createSelector(getAuthState, (ɵ1));
const ɵ2 = /**
 * @param {?} state
 * @return {?}
 */
state => state.user.loggedIn && state.user.user && state.user.user.emailVerified;
/** @type {?} */
const isUserLogged = createSelector(getAuthState, (ɵ2));
const ɵ3 = /**
 * @param {?} state
 * @return {?}
 */
state => state.user.user;
/** @type {?} */
const getUser = createSelector(getAuthState, (ɵ3));
const ɵ4 = /**
 * @param {?} state
 * @return {?}
 */
state => state.user.error;
/** @type {?} */
const getAuthError = createSelector(getAuthState, (ɵ4));
const ɵ5 = /**
 * @param {?} state
 * @return {?}
 */
state => state.user.success;
/** @type {?} */
const isAuthSuccess = createSelector(getAuthState, (ɵ5));
const ɵ6 = /**
 * @param {?} state
 * @return {?}
 */
state => state.changePassword;
/** @type {?} */
const getChangePasswordStatus = createSelector(getAuthState, (ɵ6));
const ɵ7 = /**
 * @param {?} state
 * @return {?}
 */
state => state.providers;
/** @type {?} */
const getUserProvidersState = createSelector(getAuthState, (ɵ7));
const ɵ8 = /**
 * @param {?} state
 * @return {?}
 */
state => state.providers.providers;
/** @type {?} */
const getUserProviders = createSelector(getAuthState, (ɵ8));
const ɵ9 = /**
 * @param {?} state
 * @return {?}
 */
state => {
    return {
        loading: state.providers.loading,
        error: state.providers.error,
        success: state.providers.success
    };
};
/** @type {?} */
const getProvidersRequestStatus = createSelector(getAuthState, (ɵ9));
const ɵ10 = /**
 * @param {?} state
 * @return {?}
 */
state => {
    return {
        emailVerified: {
            loading: state.customEmailHandler.emailVerified.loading,
            error: state.customEmailHandler.emailVerified.error,
            success: state.customEmailHandler.emailVerified.success
        }
    };
};
/** @type {?} */
const getCustomEmailHandlerRequestStatus = createSelector(getAuthState, (ɵ10));
const ɵ11 = /**
 * @param {?} state
 * @return {?}
 */
state => state.customEmailHandler.emailVerified;
/** @type {?} */
const getEmailVerifiedStatus = createSelector(getAuthState, (ɵ11));
const ɵ12 = /**
 * @param {?} state
 * @return {?}
 */
state => state.customEmailHandler.resetPassword;
/** @type {?} */
const getPasswordResetStatus = createSelector(getAuthState, (ɵ12));
const ɵ13 = /**
 * @param {?} state
 * @return {?}
 */
state => state.customEmailHandler.passwordResetCode;
/** @type {?} */
const getVerifyResetPasswordProcedure = createSelector(getAuthState, (ɵ13));
const ɵ14 = /**
 * @param {?} state
 * @return {?}
 */
state => state.customEmailHandler.emailVerified.error;
/** @type {?} */
const getEmailVerifiedError = createSelector(getAuthState, (ɵ14));
const ɵ15 = /**
 * @param {?} state
 * @return {?}
 */
state => state.customEmailHandler.emailVerified.loading;
/** @type {?} */
const isEmailVerifiedLoading = createSelector(getAuthState, (ɵ15));
const ɵ16 = /**
 * @param {?} state
 * @return {?}
 */
state => state.customEmailHandler.passwordResetCode.error;
/** @type {?} */
const getPasswordResetCodeError = createSelector(getAuthState, (ɵ16));
const ɵ17 = /**
 * @param {?} state
 * @return {?}
 */
state => state.customEmailHandler.passwordResetCode.loading;
/** @type {?} */
const isPasswordResetCodeLoading = createSelector(getAuthState, (ɵ17));
const ɵ18 = /**
 * @param {?} state
 * @return {?}
 */
state => state.customEmailHandler.passwordResetCode.email;
/** @type {?} */
const getPasswordResetCodeEmail = createSelector(getAuthState, (ɵ18));
const ɵ19 = /**
 * @param {?} state
 * @return {?}
 */
state => state.customEmailHandler.resetPassword.error;
/** @type {?} */
const getResetPasswordError = createSelector(getAuthState, (ɵ19));
const ɵ20 = /**
 * @param {?} state
 * @return {?}
 */
state => state.customEmailHandler.resetPassword.loading;
/** @type {?} */
const isResetPasswordLoading = createSelector(getAuthState, (ɵ20));
const ɵ21 = /**
 * @param {?} state
 * @return {?}
 */
state => state.customEmailHandler.checkCode.error;
/** @type {?} */
const getCheckCodeError = createSelector(getAuthState, (ɵ21));
const ɵ22 = /**
 * @param {?} state
 * @return {?}
 */
state => state.customEmailHandler.checkCode.loading;
/** @type {?} */
const isCheckCodeLoading = createSelector(getAuthState, (ɵ22));
const ɵ23 = /**
 * @param {?} state
 * @return {?}
 */
state => state.customEmailHandler.recoverEmail.error;
/** @type {?} */
const getRecoverEmailError = createSelector(getAuthState, (ɵ23));
const ɵ24 = /**
 * @param {?} state
 * @return {?}
 */
state => state.customEmailHandler.recoverEmail.loading;
/** @type {?} */
const isRecoverEmailLoading = createSelector(getAuthState, (ɵ24));
const ɵ25 = /**
 * @param {?} state
 * @return {?}
 */
state => state.customEmailHandler.resetPassword.error || state.customEmailHandler.passwordResetCode.error;
/** @type {?} */
const getResetPasswordOrCodeError = createSelector(getAuthState, (ɵ25));
const ɵ26 = /**
 * @param {?} state
 * @return {?}
 */
state => state.customEmailHandler.resetPassword.success;
/** @type {?} */
const getResetPasswordSuccess = createSelector(getAuthState, (ɵ26));
const ɵ27 = /**
 * @param {?} state
 * @return {?}
 */
state => state.customEmailHandler.resetPassword.loading || state.customEmailHandler.passwordResetCode.loading;
/** @type {?} */
const isResetPasswordOrCodeLoading = createSelector(getAuthState, (ɵ27));
const ɵ28 = /**
 * @param {?} state
 * @return {?}
 */
state => state.customEmailHandler.recoverEmail.error || state.customEmailHandler.checkCode.error;
/** @type {?} */
const getRecoverEmailOrCheckCodeError = createSelector(getAuthState, (ɵ28));
const ɵ29 = /**
 * @param {?} state
 * @return {?}
 */
state => state.customEmailHandler.recoverEmail.loading || state.customEmailHandler.checkCode.loading;
/** @type {?} */
const isRecoverEmailOrCheckCodeLoading = createSelector(getAuthState, (ɵ29));

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class FirebaseNgrxUserManagementService {
    constructor() { }
}
FirebaseNgrxUserManagementService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
FirebaseNgrxUserManagementService.ctorParameters = () => [];
/** @nocollapse */ FirebaseNgrxUserManagementService.ngInjectableDef = ɵɵdefineInjectable({ factory: function FirebaseNgrxUserManagementService_Factory() { return new FirebaseNgrxUserManagementService(); }, token: FirebaseNgrxUserManagementService, providedIn: "root" });

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
const PROVIDERS_MAP = {};
PROVIDERS_MAP[auth.FacebookAuthProvider.FACEBOOK_SIGN_IN_METHOD] = 'facebook';
PROVIDERS_MAP[auth.GoogleAuthProvider.GOOGLE_SIGN_IN_METHOD] = 'google';
PROVIDERS_MAP[auth.EmailAuthProvider.EMAIL_PASSWORD_SIGN_IN_METHOD] = 'password';
PROVIDERS_MAP[auth.PhoneAuthProvider.PHONE_SIGN_IN_METHOD] = 'phone';
class LoginEffects {
    /**
     * @param {?} actions$
     * @param {?} afAuth
     */
    constructor(actions$, afAuth) {
        this.actions$ = actions$;
        this.afAuth = afAuth;
        this.getUser = this.actions$.pipe(ofType(AuthActionTypes.GetUser), map((/**
         * @param {?} action
         * @return {?}
         */
        (action) => action.payload)), exhaustMap((/**
         * @param {?} payload
         * @return {?}
         */
        payload => this.afAuth.authState.pipe(take(1), switchMap((/**
         * @param {?} authData
         * @return {?}
         */
        authData => {
            console.debug(authData);
            if (authData) {
                /// User logged in
                console.debug('USER', authData);
                return zip(from(authData.getIdToken(true))).pipe(switchMap((/**
                 * @param {?} res
                 * @return {?}
                 */
                res => {
                    console.debug('providers found', authData.providerData);
                    /** @type {?} */
                    const providers = authData.providerData.reduce((/**
                     * @param {?} prev
                     * @param {?} current
                     * @return {?}
                     */
                    (prev, current) => {
                        /** @type {?} */
                        const key = PROVIDERS_MAP[current.providerId];
                        if (key) {
                            prev[key] = true;
                        }
                        return prev;
                    }), {});
                    console.debug(providers, authData.providerData.map((/**
                     * @param {?} p
                     * @return {?}
                     */
                    p => p.providerId)));
                    /** @type {?} */
                    const user = new User(authData.uid, authData.displayName, authData.email, authData.phoneNumber, authData.photoURL, authData.emailVerified);
                    return from([new SetProviders(providers), new Authenticated({ user })]);
                })));
            }
            else {
                return of(new NotAuthenticated());
            }
        }))))));
        this.googleLogin = this.actions$.pipe(ofType(AuthActionTypes.GoogleLogin), map((/**
         * @param {?} action
         * @return {?}
         */
        (action) => action.payload)), exhaustMap((/**
         * @param {?} payload
         * @return {?}
         */
        payload => {
            return from(this.doGoogleLogin()).pipe(map((/**
             * @param {?} credential
             * @return {?}
             */
            credential => {
                // successful login
                return new GetUser();
            })), catchError((/**
             * @param {?} error
             * @return {?}
             */
            error => of(new AuthError(error)))));
        })));
        this.facebookLogin = this.actions$.pipe(ofType(AuthActionTypes.FacebookLogin), map((/**
         * @param {?} action
         * @return {?}
         */
        (action) => action.payload)), exhaustMap((/**
         * @param {?} payload
         * @return {?}
         */
        payload => {
            return from(this.doFacebookLogin()).pipe(map((/**
             * @param {?} credential
             * @return {?}
             */
            credential => {
                // successful login
                return new GetUser();
            })), catchError((/**
             * @param {?} error
             * @return {?}
             */
            error => of(new AuthError(error)))));
        })));
        this.loginWithCredentials = this.actions$.pipe(ofType(AuthActionTypes.CredentialsLogin), map((/**
         * @param {?} action
         * @return {?}
         */
        (action) => {
            return {
                email: action.email,
                password: action.password,
                remember: (action.remember) ? action.remember : false
            };
        })), exhaustMap((/**
         * @param {?} credentials
         * @return {?}
         */
        credentials => {
            return from(this.doLoginWithCredentials(credentials)).pipe(map((/**
             * @param {?} p
             * @return {?}
             */
            p => {
                // successful login
                return new GetUser();
            })), catchError((/**
             * @param {?} error
             * @return {?}
             */
            error => of(new AuthError(error)))));
        })));
        this.logout = this.actions$.pipe(ofType(AuthActionTypes.Logout), map((/**
         * @param {?} action
         * @return {?}
         */
        (action) => action.payload)), exhaustMap((/**
         * @param {?} payload
         * @return {?}
         */
        payload => {
            return from(this.afAuth.auth.signOut());
        })), map((/**
         * @param {?} authData
         * @return {?}
         */
        authData => {
            return new NotAuthenticated();
        })));
        this.onDeleteNotVerifiedAccount$ = this.actions$.pipe(ofType(AuthActionTypes.DeleteAccount), switchMap((/**
         * @return {?}
         */
        () => {
            return from(this.afAuth.auth.currentUser.delete()).pipe(map((/**
             * @return {?}
             */
            () => new DeleteAccountSuccess())), catchError((/**
             * @param {?} error
             * @return {?}
             */
            error => of(new DeleteAccountError(error)))));
        })));
        this.refreshToken$ = this.actions$.pipe(ofType(AuthActionTypes.RefreshToken), tap((/**
         * @param {?} action
         * @return {?}
         */
        action => this.afAuth.auth.currentUser.getIdToken(true))));
    }
    /**
     * @private
     * @return {?}
     */
    doFacebookLogin() {
        /** @type {?} */
        const provider = new auth.FacebookAuthProvider();
        return this.afAuth.auth.signInWithPopup(provider);
    }
    /**
     * @private
     * @return {?}
     */
    doGoogleLogin() {
        /** @type {?} */
        const provider = new auth.GoogleAuthProvider();
        provider.setCustomParameters({
            prompt: 'select_account'
        });
        return this.afAuth.auth.signInWithPopup(provider);
    }
    /**
     * @private
     * @param {?} credentials
     * @return {?}
     */
    doLoginWithCredentials(credentials) {
        if (credentials.remember) {
            return this.afAuth.auth.setPersistence(auth.Auth.Persistence.LOCAL).then((/**
             * @return {?}
             */
            () => {
                return this.afAuth.auth.signInWithEmailAndPassword(credentials.email, credentials.password);
            }));
        }
        else {
            return this.afAuth.auth.setPersistence(auth.Auth.Persistence.SESSION).then((/**
             * @return {?}
             */
            () => {
                return this.afAuth.auth.signInWithEmailAndPassword(credentials.email, credentials.password);
            }));
        }
    }
}
LoginEffects.decorators = [
    { type: Injectable }
];
/** @nocollapse */
LoginEffects.ctorParameters = () => [
    { type: Actions },
    { type: AngularFireAuth }
];
__decorate([
    Effect(),
    __metadata("design:type", Observable)
], LoginEffects.prototype, "getUser", void 0);
__decorate([
    Effect(),
    __metadata("design:type", Observable)
], LoginEffects.prototype, "googleLogin", void 0);
__decorate([
    Effect(),
    __metadata("design:type", Observable)
], LoginEffects.prototype, "facebookLogin", void 0);
__decorate([
    Effect(),
    __metadata("design:type", Observable)
], LoginEffects.prototype, "loginWithCredentials", void 0);
__decorate([
    Effect(),
    __metadata("design:type", Observable)
], LoginEffects.prototype, "logout", void 0);
__decorate([
    Effect(),
    __metadata("design:type", Observable)
], LoginEffects.prototype, "onDeleteNotVerifiedAccount$", void 0);
__decorate([
    Effect({ dispatch: false }),
    __metadata("design:type", Object)
], LoginEffects.prototype, "refreshToken$", void 0);
if (false) {
    /** @type {?} */
    LoginEffects.prototype.getUser;
    /** @type {?} */
    LoginEffects.prototype.googleLogin;
    /** @type {?} */
    LoginEffects.prototype.facebookLogin;
    /** @type {?} */
    LoginEffects.prototype.loginWithCredentials;
    /** @type {?} */
    LoginEffects.prototype.logout;
    /** @type {?} */
    LoginEffects.prototype.onDeleteNotVerifiedAccount$;
    /** @type {?} */
    LoginEffects.prototype.refreshToken$;
    /**
     * @type {?}
     * @private
     */
    LoginEffects.prototype.actions$;
    /**
     * @type {?}
     * @private
     */
    LoginEffects.prototype.afAuth;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class RegistrationEffects {
    /**
     * @param {?} actions
     * @param {?} afAuth
     */
    constructor(actions, afAuth) {
        this.actions = actions;
        this.afAuth = afAuth;
        this.googleSignUp = this.actions.pipe(ofType(AuthActionTypes.GoogleRegistration), map((/**
         * @param {?} action
         * @return {?}
         */
        (action) => action.payload)), exhaustMap((/**
         * @param {?} payload
         * @return {?}
         */
        payload => {
            return from(this.doGoogleRegistration()).pipe(switchMap((/**
             * @param {?} credential
             * @return {?}
             */
            credential => {
                console.debug('credential', credential);
                /** @type {?} */
                const authData = credential.user;
                /** @type {?} */
                const photoUrl = authData.photoURL;
                /** @type {?} */
                const user = new User(authData.uid, authData.displayName, authData.email, authData.phoneNumber, photoUrl, authData.emailVerified);
                return from([new SetProviders({ google: true }), new RegistrationSuccess({ user })]);
            })), catchError((/**
             * @param {?} error
             * @return {?}
             */
            error => of(new AuthError(error)))));
        })));
        this.facebookSignUp = this.actions.pipe(ofType(AuthActionTypes.FacebookRegistration), map((/**
         * @param {?} action
         * @return {?}
         */
        (action) => action.payload)), exhaustMap((/**
         * @param {?} payload
         * @return {?}
         */
        payload => {
            return from(this.doFacebookRegistration()).pipe(switchMap((/**
             * @param {?} credential
             * @return {?}
             */
            credential => {
                console.debug('facebookSignUp', credential);
                /** @type {?} */
                const authData = credential.user;
                /** @type {?} */
                const photoUrl = authData.photoURL;
                console.log('PhotoUrl', photoUrl);
                /** @type {?} */
                const user = new User(authData.uid, authData.displayName, authData.email, authData.phoneNumber, photoUrl, authData.emailVerified);
                return from([new SetProviders({ facebook: true }), new RegistrationSuccess({ user })]);
            })), catchError((/**
             * @param {?} error
             * @return {?}
             */
            error => of(new AuthError(error)))));
        })));
        this.signUpWithCredentials = this.actions.pipe(ofType(AuthActionTypes.CredentialsRegistration), map((/**
         * @param {?} action
         * @return {?}
         */
        (action) => {
            return {
                email: action.payload.email,
                password: action.payload.password
            };
        })), exhaustMap((/**
         * @param {?} credentials
         * @return {?}
         */
        credentials => {
            return from(this.doSignUpWithCredentials(credentials)).pipe(map((/**
             * @param {?} credential
             * @return {?}
             */
            credential => {
                console.debug('doSignUpWithCredentials', credential);
                /** @type {?} */
                const authData = credential.user;
                /** @type {?} */
                const user = new User(authData.uid, authData.displayName, authData.email, authData.phoneNumber, authData.photoURL, authData.emailVerified);
                return new RegistrationSuccess({ user });
            })), catchError((/**
             * @param {?} error
             * @return {?}
             */
            error => of(new AuthError(error)))));
        })));
        this.sendVerificationEmail$ = this.actions.pipe(ofType(AuthActionTypes.SendVerificationEmail), map((/**
         * @param {?} action
         * @return {?}
         */
        action => action.payload)), exhaustMap((/**
         * @param {?} payload
         * @return {?}
         */
        payload => {
            return from(this.afAuth.auth.currentUser.sendEmailVerification({ url: payload.redirectUrl })).pipe(map((/**
             * @param {?} p
             * @return {?}
             */
            p => {
                return new VerificationEmailSent();
            })), catchError((/**
             * @param {?} error
             * @return {?}
             */
            error => of(new VerificationEmailError(error)))));
        })));
    }
    /**
     * @private
     * @return {?}
     */
    doFacebookRegistration() {
        /** @type {?} */
        const provider = new auth.FacebookAuthProvider();
        return this.afAuth.auth.signInWithPopup(provider);
    }
    /**
     * @private
     * @return {?}
     */
    doGoogleRegistration() {
        /** @type {?} */
        const provider = new auth.GoogleAuthProvider();
        provider.setCustomParameters({
            prompt: 'select_account'
        });
        return this.afAuth.auth.signInWithPopup(provider);
    }
    /**
     * @private
     * @param {?} credentials
     * @return {?}
     */
    doSignUpWithCredentials(credentials) {
        return this.afAuth.auth.createUserWithEmailAndPassword(credentials.email, credentials.password);
    }
}
RegistrationEffects.decorators = [
    { type: Injectable }
];
/** @nocollapse */
RegistrationEffects.ctorParameters = () => [
    { type: Actions },
    { type: AngularFireAuth }
];
__decorate([
    Effect(),
    __metadata("design:type", Observable)
], RegistrationEffects.prototype, "googleSignUp", void 0);
__decorate([
    Effect(),
    __metadata("design:type", Observable)
], RegistrationEffects.prototype, "facebookSignUp", void 0);
__decorate([
    Effect(),
    __metadata("design:type", Observable)
], RegistrationEffects.prototype, "signUpWithCredentials", void 0);
__decorate([
    Effect(),
    __metadata("design:type", Observable)
], RegistrationEffects.prototype, "sendVerificationEmail$", void 0);
if (false) {
    /** @type {?} */
    RegistrationEffects.prototype.googleSignUp;
    /** @type {?} */
    RegistrationEffects.prototype.facebookSignUp;
    /** @type {?} */
    RegistrationEffects.prototype.signUpWithCredentials;
    /** @type {?} */
    RegistrationEffects.prototype.sendVerificationEmail$;
    /**
     * @type {?}
     * @private
     */
    RegistrationEffects.prototype.actions;
    /**
     * @type {?}
     * @private
     */
    RegistrationEffects.prototype.afAuth;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class ReAuthenticationEffects {
    /**
     * @param {?} actions
     * @param {?} afAuth
     */
    constructor(actions, afAuth) {
        this.actions = actions;
        this.afAuth = afAuth;
        this.googleReAuthentication = this.actions.pipe(ofType(AuthActionTypes.GoogleReAuthentication), map((/**
         * @param {?} action
         * @return {?}
         */
        (action) => action.payload)), exhaustMap((/**
         * @param {?} payload
         * @return {?}
         */
        payload => {
            return from(this.doGoogleReAuthentication()).pipe(map((/**
             * @param {?} credential
             * @return {?}
             */
            credential => {
                // successful login
                return new ReAuthenticationSuccess();
            })), catchError((/**
             * @param {?} error
             * @return {?}
             */
            error => of(new ReAuthenticationError(error)))));
        })));
        this.facebookReAuthentication = this.actions.pipe(ofType(AuthActionTypes.FacebookReAuthentication), map((/**
         * @param {?} action
         * @return {?}
         */
        (action) => action.payload)), exhaustMap((/**
         * @param {?} payload
         * @return {?}
         */
        payload => {
            return from(this.doFacebookReAuthentication()).pipe(map((/**
             * @param {?} credential
             * @return {?}
             */
            credential => {
                // successful login
                return new ReAuthenticationSuccess();
            })), catchError((/**
             * @param {?} error
             * @return {?}
             */
            error => of(new ReAuthenticationError(error)))));
        })));
        this.reAuthenticateWithCredentials = this.actions.pipe(ofType(AuthActionTypes.CredentialsReAuthentication), map((/**
         * @param {?} action
         * @return {?}
         */
        (action) => {
            return {
                email: action.email,
                password: action.password
            };
        })), exhaustMap((/**
         * @param {?} credentials
         * @return {?}
         */
        credentials => {
            return from(this.doReAuthenticationWithCredentials(credentials)).pipe(map((/**
             * @param {?} p
             * @return {?}
             */
            p => {
                // successful login
                return new ReAuthenticationSuccess();
            })), catchError((/**
             * @param {?} error
             * @return {?}
             */
            error => of(new ReAuthenticationError(error)))));
        })));
    }
    /**
     * @private
     * @return {?}
     */
    doFacebookReAuthentication() {
        /** @type {?} */
        const provider = new auth.FacebookAuthProvider();
        return this.afAuth.auth.currentUser.reauthenticateWithPopup(provider);
    }
    /**
     * @private
     * @return {?}
     */
    doGoogleReAuthentication() {
        /** @type {?} */
        const provider = new auth.GoogleAuthProvider();
        return this.afAuth.auth.currentUser.reauthenticateWithPopup(provider);
    }
    /**
     * @private
     * @param {?} credentials
     * @return {?}
     */
    doReAuthenticationWithCredentials(credentials) {
        /** @type {?} */
        const credential = auth.EmailAuthProvider.credential(credentials.email, credentials.password);
        return this.afAuth.auth.currentUser.reauthenticateAndRetrieveDataWithCredential(credential);
    }
}
ReAuthenticationEffects.decorators = [
    { type: Injectable }
];
/** @nocollapse */
ReAuthenticationEffects.ctorParameters = () => [
    { type: Actions },
    { type: AngularFireAuth }
];
__decorate([
    Effect(),
    __metadata("design:type", Observable)
], ReAuthenticationEffects.prototype, "googleReAuthentication", void 0);
__decorate([
    Effect(),
    __metadata("design:type", Observable)
], ReAuthenticationEffects.prototype, "facebookReAuthentication", void 0);
__decorate([
    Effect(),
    __metadata("design:type", Observable)
], ReAuthenticationEffects.prototype, "reAuthenticateWithCredentials", void 0);
if (false) {
    /** @type {?} */
    ReAuthenticationEffects.prototype.googleReAuthentication;
    /** @type {?} */
    ReAuthenticationEffects.prototype.facebookReAuthentication;
    /** @type {?} */
    ReAuthenticationEffects.prototype.reAuthenticateWithCredentials;
    /**
     * @type {?}
     * @private
     */
    ReAuthenticationEffects.prototype.actions;
    /**
     * @type {?}
     * @private
     */
    ReAuthenticationEffects.prototype.afAuth;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var EmailAuthProvider = auth.EmailAuthProvider;
class ProvidersManagementEffects {
    /**
     * @param {?} actions$
     * @param {?} afAuth
     */
    constructor(actions$, afAuth) {
        this.actions$ = actions$;
        this.afAuth = afAuth;
        this.linkToGoogleAccount$ = this.actions$.pipe(ofType(ProvidersManagementActionTypes.LinkGoogleAccount), exhaustMap((/**
         * @param {?} actins
         * @return {?}
         */
        actins => {
            return from(this.doLinkToGoogleProvider()).pipe(mapTo(new LinkSuccess({ provider: 'google' })), catchError((/**
             * @param {?} error
             * @return {?}
             */
            error => of(new LinkError(error)))));
        })));
        this.linkToFacebookAccount$ = this.actions$.pipe(ofType(ProvidersManagementActionTypes.LinkFacebookAccount), exhaustMap((/**
         * @param {?} actions
         * @return {?}
         */
        actions => {
            return from(this.doLinkToFacebookProvider()).pipe(mapTo(new LinkSuccess({ provider: 'facebook' })), catchError((/**
             * @param {?} error
             * @return {?}
             */
            error => of(new LinkError(error)))));
        })));
        this.linkToCredentialsAccount$ = this.actions$.pipe(ofType(ProvidersManagementActionTypes.LinkCredentialAccount), map((/**
         * @param {?} action
         * @return {?}
         */
        action => action.payload)), exhaustMap((/**
         * @param {?} payload
         * @return {?}
         */
        payload => {
            return from(this.reAuthenticate().then((/**
             * @param {?} res
             * @return {?}
             */
            (res) => __awaiter(this, void 0, void 0, function* () {
                yield this.doLinkToCredentials(this.afAuth.auth.currentUser.email, payload.password);
            })))).pipe(mapTo(new LinkSuccess({ provider: 'password' })), catchError((/**
             * @param {?} error
             * @return {?}
             */
            error => {
                if (error.code === 'auth/popup-blocked') {
                    return from(this.reAuthenticateWithRedirect().then((/**
                     * @param {?} res
                     * @return {?}
                     */
                    (res) => __awaiter(this, void 0, void 0, function* () {
                        yield this.doLinkToCredentials(this.afAuth.auth.currentUser.email, payload.password);
                    })))).pipe(mapTo(new LinkSuccess({ provider: 'password' })), catchError((/**
                     * @param {?} error1
                     * @return {?}
                     */
                    error1 => of(new LinkError(error1)))));
                }
                else {
                    return of(new LinkError(error));
                }
            })));
        })));
        this.unlinkGoogleAccount$ = this.actions$.pipe(ofType(ProvidersManagementActionTypes.UnlinkGoogleAccount), exhaustMap((/**
         * @param {?} actions
         * @return {?}
         */
        actions => {
            return from(this.doUnlinkToGoogleProvider()).pipe(mapTo(new UnlinkSuccess({ provider: 'google' })), catchError((/**
             * @param {?} error
             * @return {?}
             */
            error => of(new UnlinkError(error)))));
        })));
        this.unlinkFacebookAccount$ = this.actions$.pipe(ofType(ProvidersManagementActionTypes.UnlinkFacebookAccount), exhaustMap((/**
         * @param {?} actions
         * @return {?}
         */
        actions => {
            return from(this.doUnlinkToFacebookProvider()).pipe(mapTo(new UnlinkSuccess({ provider: 'facebook' })), catchError((/**
             * @param {?} error
             * @return {?}
             */
            error => of(new UnlinkError(error)))));
        })));
        this.unlinkCredentialsAccount$ = this.actions$.pipe(ofType(ProvidersManagementActionTypes.UnlinkCredentialAccount), exhaustMap((/**
         * @param {?} action
         * @return {?}
         */
        action => {
            return from(this.reAuthenticate().then((/**
             * @param {?} res
             * @return {?}
             */
            (res) => __awaiter(this, void 0, void 0, function* () {
                yield this.doUnlinkToCredentials();
            })))).pipe(mapTo(new UnlinkSuccess({ provider: 'password' })), catchError((/**
             * @param {?} error
             * @return {?}
             */
            error => of(new UnlinkError(error)))));
        })));
        this.unlinkPhone$ = this.actions$.pipe(ofType(ProvidersManagementActionTypes.UnlinkPhoneNumber), exhaustMap((/**
         * @param {?} action
         * @return {?}
         */
        action => {
            return from(this.doUnlinkPhoneNumber()).pipe(mapTo(new UnlinkSuccess({ provider: 'phone' })), catchError((/**
             * @param {?} error
             * @return {?}
             */
            error => of(new UnlinkError(error)))));
        })));
        this.sendCodeToPhone$ = this.actions$.pipe(ofType(ProvidersManagementActionTypes.SendPhoneNumberCode), map((/**
         * @param {?} action
         * @return {?}
         */
        action => action.payload)), exhaustMap((/**
         * @param {?} payload
         * @return {?}
         */
        payload => {
            return from(((/**
             * @return {?}
             */
            () => {
                return this.afAuth.auth.currentUser.linkWithPhoneNumber(payload.number, new auth.RecaptchaVerifier(payload.captchaContainerId, {
                    size: 'invisible',
                    callback: (/**
                     * @param {?} token
                     * @return {?}
                     */
                    token => {
                        console.debug('Captcha token', token);
                    })
                })).then((/**
                 * @param {?} confirmation
                 * @return {?}
                 */
                confirmation => {
                    this.phoneNumberConfirmation = confirmation;
                }));
            }))()).pipe(mapTo(new CodeSent()), catchError((/**
             * @param {?} error
             * @return {?}
             */
            error => of(new LinkError(error)))));
        })));
        this.verifyCode$ = this.actions$.pipe(ofType(ProvidersManagementActionTypes.VerifyPhoneNumber), map((/**
         * @param {?} action
         * @return {?}
         */
        action => action.payload)), exhaustMap((/**
         * @param {?} payload
         * @return {?}
         */
        payload => {
            return from(this.phoneNumberConfirmation.confirm(payload.code)).pipe(mapTo(new LinkSuccess({ provider: 'phone' })), catchError((/**
             * @param {?} error
             * @return {?}
             */
            error => of(new LinkError(error)))));
        })));
    }
    /**
     * @private
     * @return {?}
     */
    doLinkToGoogleProvider() {
        /** @type {?} */
        const provider = new auth.GoogleAuthProvider();
        return this.afAuth.auth.currentUser.linkWithPopup(provider);
    }
    /**
     * @private
     * @return {?}
     */
    doUnlinkToGoogleProvider() {
        /** @type {?} */
        const provider = new auth.GoogleAuthProvider();
        return this.afAuth.auth.currentUser.unlink(provider.providerId);
    }
    /**
     * @private
     * @return {?}
     */
    doLinkToFacebookProvider() {
        /** @type {?} */
        const provider = new auth.FacebookAuthProvider();
        return this.afAuth.auth.currentUser.linkWithPopup(provider);
    }
    /**
     * @private
     * @return {?}
     */
    doUnlinkToFacebookProvider() {
        /** @type {?} */
        const provider = new auth.FacebookAuthProvider();
        return this.afAuth.auth.currentUser.unlink(provider.providerId);
    }
    /**
     * @private
     * @return {?}
     */
    doUnlinkPhoneNumber() {
        /** @type {?} */
        const provider = new auth.PhoneAuthProvider();
        return this.afAuth.auth.currentUser.unlink(provider.providerId);
    }
    /**
     * @private
     * @param {?} email
     * @param {?} password
     * @return {?}
     */
    doLinkToCredentials(email, password) {
        /** @type {?} */
        const credentials = EmailAuthProvider.credential(email, password);
        return this.afAuth.auth.currentUser.linkAndRetrieveDataWithCredential(credentials);
    }
    /**
     * @private
     * @return {?}
     */
    doUnlinkToCredentials() {
        return this.afAuth.auth.currentUser.unlink(EmailAuthProvider.EMAIL_PASSWORD_SIGN_IN_METHOD);
    }
    /**
     * @private
     * @return {?}
     */
    doFacebookReAuthentication() {
        /** @type {?} */
        const provider = new auth.FacebookAuthProvider();
        return this.afAuth.auth.currentUser.reauthenticateWithPopup(provider);
    }
    /**
     * @private
     * @return {?}
     */
    doFacebookReAuthenticationWithRedirect() {
        /** @type {?} */
        const provider = new auth.FacebookAuthProvider();
        return this.afAuth.auth.currentUser.reauthenticateWithRedirect(provider);
    }
    /**
     * @private
     * @return {?}
     */
    reAuthenticate() {
        return this.afAuth.auth.fetchSignInMethodsForEmail(this.afAuth.auth.currentUser.email).then((/**
         * @param {?} res
         * @return {?}
         */
        (res) => __awaiter(this, void 0, void 0, function* () {
            if (res.indexOf('facebook.com') >= 0) {
                yield this.doFacebookReAuthentication();
                return;
            }
            else {
                yield this.doGoogleReAuthentication();
                return;
            }
        })));
    }
    /**
     * @private
     * @return {?}
     */
    reAuthenticateWithRedirect() {
        return this.afAuth.auth.fetchSignInMethodsForEmail(this.afAuth.auth.currentUser.email).then((/**
         * @param {?} res
         * @return {?}
         */
        (res) => __awaiter(this, void 0, void 0, function* () {
            if (res.indexOf('facebook.com') >= 0) {
                yield this.doFacebookReAuthenticationWithRedirect();
                return;
            }
            else {
                yield this.doGoogleReAuthenticationWithRedirect();
                return;
            }
        })));
    }
    /**
     * @private
     * @return {?}
     */
    doGoogleReAuthentication() {
        /** @type {?} */
        const provider = new auth.GoogleAuthProvider();
        return this.afAuth.auth.currentUser.reauthenticateWithPopup(provider);
    }
    /**
     * @private
     * @return {?}
     */
    doGoogleReAuthenticationWithRedirect() {
        /** @type {?} */
        const provider = new auth.GoogleAuthProvider();
        return this.afAuth.auth.currentUser.reauthenticateWithPopup(provider);
    }
}
ProvidersManagementEffects.decorators = [
    { type: Injectable }
];
/** @nocollapse */
ProvidersManagementEffects.ctorParameters = () => [
    { type: Actions },
    { type: AngularFireAuth }
];
__decorate([
    Effect(),
    __metadata("design:type", Observable)
], ProvidersManagementEffects.prototype, "linkToGoogleAccount$", void 0);
__decorate([
    Effect(),
    __metadata("design:type", Observable)
], ProvidersManagementEffects.prototype, "linkToFacebookAccount$", void 0);
__decorate([
    Effect(),
    __metadata("design:type", Observable)
], ProvidersManagementEffects.prototype, "linkToCredentialsAccount$", void 0);
__decorate([
    Effect(),
    __metadata("design:type", Observable)
], ProvidersManagementEffects.prototype, "unlinkGoogleAccount$", void 0);
__decorate([
    Effect(),
    __metadata("design:type", Observable)
], ProvidersManagementEffects.prototype, "unlinkFacebookAccount$", void 0);
__decorate([
    Effect(),
    __metadata("design:type", Observable)
], ProvidersManagementEffects.prototype, "unlinkCredentialsAccount$", void 0);
__decorate([
    Effect(),
    __metadata("design:type", Observable)
], ProvidersManagementEffects.prototype, "unlinkPhone$", void 0);
__decorate([
    Effect(),
    __metadata("design:type", Observable)
], ProvidersManagementEffects.prototype, "sendCodeToPhone$", void 0);
__decorate([
    Effect(),
    __metadata("design:type", Observable)
], ProvidersManagementEffects.prototype, "verifyCode$", void 0);
if (false) {
    /** @type {?} */
    ProvidersManagementEffects.prototype.linkToGoogleAccount$;
    /** @type {?} */
    ProvidersManagementEffects.prototype.linkToFacebookAccount$;
    /** @type {?} */
    ProvidersManagementEffects.prototype.linkToCredentialsAccount$;
    /** @type {?} */
    ProvidersManagementEffects.prototype.unlinkGoogleAccount$;
    /** @type {?} */
    ProvidersManagementEffects.prototype.unlinkFacebookAccount$;
    /** @type {?} */
    ProvidersManagementEffects.prototype.unlinkCredentialsAccount$;
    /** @type {?} */
    ProvidersManagementEffects.prototype.unlinkPhone$;
    /** @type {?} */
    ProvidersManagementEffects.prototype.sendCodeToPhone$;
    /** @type {?} */
    ProvidersManagementEffects.prototype.verifyCode$;
    /**
     * @type {?}
     * @private
     */
    ProvidersManagementEffects.prototype.phoneNumberConfirmation;
    /**
     * @type {?}
     * @private
     */
    ProvidersManagementEffects.prototype.actions$;
    /**
     * @type {?}
     * @private
     */
    ProvidersManagementEffects.prototype.afAuth;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class PasswordManagementEffects {
    /**
     * @param {?} actions$
     * @param {?} afAuth
     */
    constructor(actions$, afAuth) {
        this.actions$ = actions$;
        this.afAuth = afAuth;
        this.changePassword = this.actions$.pipe(ofType(PasswordManagementActionTypes.ChangePasswordRequest), map((/**
         * @param {?} action
         * @return {?}
         */
        action => action.payload)), exhaustMap((/**
         * @param {?} payload
         * @return {?}
         */
        payload => {
            /** @type {?} */
            const credentials = auth.EmailAuthProvider.credential(this.afAuth.auth.currentUser.email, payload.oldPassword);
            return from(this.afAuth.auth.currentUser.reauthenticateAndRetrieveDataWithCredential(credentials).then((/**
             * @param {?} res
             * @return {?}
             */
            (res) => __awaiter(this, void 0, void 0, function* () {
                yield this.afAuth.auth.currentUser.updatePassword(payload.newPassword);
                return;
            })))).pipe(mapTo(new ChangePasswordSuccess()), catchError((/**
             * @param {?} error
             * @return {?}
             */
            error => of(new ChangePasswordError(error)))));
        })));
        this.passwordForgotten$ = this.actions$.pipe(ofType(PasswordManagementActionTypes.ResetPasswordRequest), map((/**
         * @param {?} action
         * @return {?}
         */
        action => action.payload)), exhaustMap((/**
         * @param {?} payload
         * @return {?}
         */
        payload => {
            return from(this.afAuth.auth.sendPasswordResetEmail(payload.email, { url: payload.redirectUrl })).pipe(map((/**
             * @param {?} authData
             * @return {?}
             */
            authData => {
                return new ResetPasswordRequestSuccess();
            })), catchError((/**
             * @param {?} err
             * @return {?}
             */
            err => of(new ResetPasswordRequestError(err)))));
        })));
    }
}
PasswordManagementEffects.decorators = [
    { type: Injectable }
];
/** @nocollapse */
PasswordManagementEffects.ctorParameters = () => [
    { type: Actions },
    { type: AngularFireAuth }
];
__decorate([
    Effect(),
    __metadata("design:type", Observable)
], PasswordManagementEffects.prototype, "changePassword", void 0);
__decorate([
    Effect(),
    __metadata("design:type", Object)
], PasswordManagementEffects.prototype, "passwordForgotten$", void 0);
if (false) {
    /** @type {?} */
    PasswordManagementEffects.prototype.changePassword;
    /** @type {?} */
    PasswordManagementEffects.prototype.passwordForgotten$;
    /**
     * @type {?}
     * @private
     */
    PasswordManagementEffects.prototype.actions$;
    /**
     * @type {?}
     * @private
     */
    PasswordManagementEffects.prototype.afAuth;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class CustomEmailHandlerEffects {
    /**
     * @param {?} actions$
     * @param {?} afAuth
     */
    constructor(actions$, afAuth) {
        this.actions$ = actions$;
        this.afAuth = afAuth;
        this.verifyEmail = this.actions$.pipe(ofType(CustomEmailHandlerActionTypes.VerifyEmailAddress), map((/**
         * @param {?} action
         * @return {?}
         */
        action => action.payload)), switchMap((/**
         * @param {?} payload
         * @return {?}
         */
        payload => {
            return from(this.afAuth.auth.applyActionCode(payload.actionCode).then((/**
             * @param {?} res
             * @return {?}
             */
            (res) => __awaiter(this, void 0, void 0, function* () {
            })))).pipe(mapTo(new VerifyEmailAddressSuccess()), catchError((/**
             * @param {?} error
             * @return {?}
             */
            error => of(new VerifyEmailAddressError(error)))));
        })));
        this.verifyPasswordResetCode = this.actions$.pipe(ofType(CustomEmailHandlerActionTypes.VerifyPasswordResetCode), map((/**
         * @param {?} action
         * @return {?}
         */
        action => action.payload)), switchMap((/**
         * @param {?} payload
         * @return {?}
         */
        payload => {
            return from(this.afAuth.auth.verifyPasswordResetCode(payload.actionCode)).pipe(switchMap((/**
             * @param {?} email
             * @return {?}
             */
            (email) => {
                return of(new VerifyPasswordResetCodeSuccess({ email, actionCode: payload.actionCode }));
            })), catchError((/**
             * @param {?} error
             * @return {?}
             */
            error => of(new VerifyPasswordResetCodeError(error)))));
        })));
        this.resetPassword = this.actions$.pipe(ofType(CustomEmailHandlerActionTypes.ResetPassword), map((/**
         * @param {?} action
         * @return {?}
         */
        action => action.payload)), switchMap((/**
         * @param {?} payload
         * @return {?}
         */
        payload => {
            return from(this.afAuth.auth.confirmPasswordReset(payload.actionCode, payload.newPassword)).pipe(switchMap((/**
             * @return {?}
             */
            () => {
                return of(new ResetPasswordSuccess());
            })), catchError((/**
             * @param {?} error
             * @return {?}
             */
            error => of(new ResetPasswordError(error)))));
        })));
        this.checkActionCode = this.actions$.pipe(ofType(CustomEmailHandlerActionTypes.CheckActionCode), map((/**
         * @param {?} action
         * @return {?}
         */
        action => action.payload)), switchMap((/**
         * @param {?} payload
         * @return {?}
         */
        payload => {
            return from(this.afAuth.auth.checkActionCode(payload.actionCode)).pipe(map((/**
             * @param {?} info
             * @return {?}
             */
            info => info['data']['email'])), switchMap((/**
             * @param {?} restoredEmail
             * @return {?}
             */
            (restoredEmail) => {
                return of(new CheckActionCodeSuccess({ actionCode: payload.actionCode, restoredEmail }));
            })), catchError((/**
             * @param {?} error
             * @return {?}
             */
            error => of(new CheckActionCodeError(error)))));
        })));
        this.revertOldEmail = this.actions$.pipe(ofType(CustomEmailHandlerActionTypes.RecoverEmail), map((/**
         * @param {?} action
         * @return {?}
         */
        action => action.payload)), switchMap((/**
         * @param {?} payload
         * @return {?}
         */
        payload => {
            return from(this.afAuth.auth.applyActionCode(payload.actionCode)).pipe(switchMap((/**
             * @return {?}
             */
            () => {
                return of(new RecoverEmailSuccess());
            })), catchError((/**
             * @param {?} error
             * @return {?}
             */
            error => of(new RecoverEmailError(error)))));
        })));
    }
}
CustomEmailHandlerEffects.decorators = [
    { type: Injectable }
];
/** @nocollapse */
CustomEmailHandlerEffects.ctorParameters = () => [
    { type: Actions },
    { type: AngularFireAuth }
];
__decorate([
    Effect(),
    __metadata("design:type", Observable)
], CustomEmailHandlerEffects.prototype, "verifyEmail", void 0);
__decorate([
    Effect(),
    __metadata("design:type", Observable)
], CustomEmailHandlerEffects.prototype, "verifyPasswordResetCode", void 0);
__decorate([
    Effect(),
    __metadata("design:type", Observable)
], CustomEmailHandlerEffects.prototype, "resetPassword", void 0);
__decorate([
    Effect(),
    __metadata("design:type", Observable)
], CustomEmailHandlerEffects.prototype, "checkActionCode", void 0);
__decorate([
    Effect(),
    __metadata("design:type", Observable)
], CustomEmailHandlerEffects.prototype, "revertOldEmail", void 0);
if (false) {
    /** @type {?} */
    CustomEmailHandlerEffects.prototype.verifyEmail;
    /** @type {?} */
    CustomEmailHandlerEffects.prototype.verifyPasswordResetCode;
    /** @type {?} */
    CustomEmailHandlerEffects.prototype.resetPassword;
    /** @type {?} */
    CustomEmailHandlerEffects.prototype.checkActionCode;
    /** @type {?} */
    CustomEmailHandlerEffects.prototype.revertOldEmail;
    /**
     * @type {?}
     * @private
     */
    CustomEmailHandlerEffects.prototype.actions$;
    /**
     * @type {?}
     * @private
     */
    CustomEmailHandlerEffects.prototype.afAuth;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class FirebaseNgrxUserManagementModule {
}
FirebaseNgrxUserManagementModule.decorators = [
    { type: NgModule, args: [{
                imports: [
                    AngularFireModule,
                    AngularFireAuthModule,
                    EffectsModule.forFeature([
                        CustomEmailHandlerEffects,
                        LoginEffects,
                        ReAuthenticationEffects,
                        RegistrationEffects,
                        ProvidersManagementEffects,
                        PasswordManagementEffects
                    ]),
                    StoreModule.forFeature('auth', reducers)
                ],
                declarations: [],
                exports: [],
                providers: []
            },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { auth_actions as AuthActions, customEmailHandler_actions as CustomEmailHandlerActions, FirebaseNgrxUserManagementModule, FirebaseNgrxUserManagementService, passwordManagement_actions as PasswordManagementActions, providersManagement_actions as ProvidersManagementActions, User, getAuthError, getAuthState, getChangePasswordStatus, getCheckCodeError, getCustomEmailHandlerRequestStatus, getEmailVerifiedError, getEmailVerifiedStatus, getPasswordResetCodeEmail, getPasswordResetCodeError, getPasswordResetStatus, getProvidersRequestStatus, getRecoverEmailError, getRecoverEmailOrCheckCodeError, getResetPasswordError, getResetPasswordOrCodeError, getResetPasswordSuccess, getUser, getUserProviders, getUserProvidersState, getUserState, getVerifyResetPasswordProcedure, isAuthLoading, isAuthSuccess, isCheckCodeLoading, isEmailVerifiedLoading, isPasswordResetCodeLoading, isRecoverEmailLoading, isRecoverEmailOrCheckCodeLoading, isResetPasswordLoading, isResetPasswordOrCodeLoading, isUserLogged, reducers as ɵa, reducer as ɵb, reducer$2 as ɵc, CustomEmailHandlerEffects as ɵd, LoginEffects as ɵe, ReAuthenticationEffects as ɵf, RegistrationEffects as ɵg, ProvidersManagementEffects as ɵh, PasswordManagementEffects as ɵi, reducer$1 as ɵj, reducer$3 as ɵk };
//# sourceMappingURL=xtream-firebase-ngrx-user-management.js.map
