import { createFeatureSelector, createSelector, StoreModule } from '@ngrx/store';
import { AngularFireModule } from '@angular/fire';
import { auth } from 'firebase/app';
import 'firebase/auth';
import { __awaiter, __generator, __decorate, __metadata, __assign } from 'tslib';
import { Injectable, NgModule, defineInjectable } from '@angular/core';
import { Actions, Effect, ofType, EffectsModule } from '@ngrx/effects';
import { AngularFireAuth, AngularFireAuthModule } from '@angular/fire/auth';
import { from, Observable, of, zip } from 'rxjs';
import { catchError, exhaustMap, map, switchMap, take, tap, mapTo } from 'rxjs/operators';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var User = /** @class */ (function () {
    function User(uid, displayName, email, phoneNumber, photoURL, emailVerified) {
        this.uid = uid;
        this.displayName = displayName;
        this.email = email;
        this.phoneNumber = phoneNumber;
        this.photoURL = photoURL;
        this.emailVerified = emailVerified;
    }
    return User;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @enum {string} */
var CustomEmailHandlerActionTypes = {
    CheckActionCode: '[Auth/CustomEmailHandler] Check Action Code',
    CheckActionCodeError: '[Auth/CustomEmailHandler] Check Action Code Error',
    CheckActionCodeSuccess: '[Auth/CustomEmailHandler] Check Action Code Success',
    RecoverEmail: '[Auth/CustomEmailHandler] Recover Email',
    RecoverEmailSuccess: '[Auth/CustomEmailHandler] Recover Email Success',
    RecoverEmailError: '[Auth/CustomEmailHandler] Recover Email Error',
    ResetPassword: '[Auth/CustomEmailHandler] Reset Password',
    ResetPasswordSuccess: '[Auth/CustomEmailHandler] Reset Password Success',
    ResetPasswordError: '[Auth/CustomEmailHandler] Reset Password Error',
    VerifyEmailAddress: '[Auth/CustomEmailHandler] Verify Email Address',
    VerifyEmailAddressSuccess: '[Auth/CustomEmailHandler] Verify Email Address Success',
    VerifyEmailAddressError: '[Auth/CustomEmailHandler] Verify Email Address Error',
    VerifyPasswordResetCode: '[Auth/CustomEmailHandler] Verify Password Reset Code',
    VerifyPasswordResetCodeError: '[Auth/CustomEmailHandler] Verify Password Reset Error',
    VerifyPasswordResetCodeSuccess: '[Auth/CustomEmailHandler] Verify Password Reset Success',
};
var CheckActionCode = /** @class */ (function () {
    function CheckActionCode(payload) {
        this.payload = payload;
        this.type = CustomEmailHandlerActionTypes.CheckActionCode;
    }
    return CheckActionCode;
}());
var CheckActionCodeError = /** @class */ (function () {
    function CheckActionCodeError(payload) {
        this.payload = payload;
        this.type = CustomEmailHandlerActionTypes.CheckActionCodeError;
    }
    return CheckActionCodeError;
}());
var CheckActionCodeSuccess = /** @class */ (function () {
    function CheckActionCodeSuccess(payload) {
        this.payload = payload;
        this.type = CustomEmailHandlerActionTypes.CheckActionCodeSuccess;
    }
    return CheckActionCodeSuccess;
}());
var RecoverEmail = /** @class */ (function () {
    function RecoverEmail(payload) {
        this.payload = payload;
        this.type = CustomEmailHandlerActionTypes.RecoverEmail;
    }
    return RecoverEmail;
}());
var RecoverEmailError = /** @class */ (function () {
    function RecoverEmailError(payload) {
        this.payload = payload;
        this.type = CustomEmailHandlerActionTypes.RecoverEmailError;
    }
    return RecoverEmailError;
}());
var RecoverEmailSuccess = /** @class */ (function () {
    function RecoverEmailSuccess() {
        this.type = CustomEmailHandlerActionTypes.RecoverEmailSuccess;
    }
    return RecoverEmailSuccess;
}());
var ResetPassword = /** @class */ (function () {
    function ResetPassword(payload) {
        this.payload = payload;
        this.type = CustomEmailHandlerActionTypes.ResetPassword;
    }
    return ResetPassword;
}());
var ResetPasswordError = /** @class */ (function () {
    function ResetPasswordError(payload) {
        this.payload = payload;
        this.type = CustomEmailHandlerActionTypes.ResetPasswordError;
    }
    return ResetPasswordError;
}());
var ResetPasswordSuccess = /** @class */ (function () {
    function ResetPasswordSuccess() {
        this.type = CustomEmailHandlerActionTypes.ResetPasswordSuccess;
    }
    return ResetPasswordSuccess;
}());
var VerifyEmailAddress = /** @class */ (function () {
    function VerifyEmailAddress(payload) {
        this.payload = payload;
        this.type = CustomEmailHandlerActionTypes.VerifyEmailAddress;
    }
    return VerifyEmailAddress;
}());
var VerifyEmailAddressError = /** @class */ (function () {
    function VerifyEmailAddressError(payload) {
        this.payload = payload;
        this.type = CustomEmailHandlerActionTypes.VerifyEmailAddressError;
    }
    return VerifyEmailAddressError;
}());
var VerifyEmailAddressSuccess = /** @class */ (function () {
    function VerifyEmailAddressSuccess() {
        this.type = CustomEmailHandlerActionTypes.VerifyEmailAddressSuccess;
    }
    return VerifyEmailAddressSuccess;
}());
var VerifyPasswordResetCode = /** @class */ (function () {
    function VerifyPasswordResetCode(payload) {
        this.payload = payload;
        this.type = CustomEmailHandlerActionTypes.VerifyPasswordResetCode;
    }
    return VerifyPasswordResetCode;
}());
var VerifyPasswordResetCodeError = /** @class */ (function () {
    function VerifyPasswordResetCodeError(payload) {
        this.payload = payload;
        this.type = CustomEmailHandlerActionTypes.VerifyPasswordResetCodeError;
    }
    return VerifyPasswordResetCodeError;
}());
var VerifyPasswordResetCodeSuccess = /** @class */ (function () {
    function VerifyPasswordResetCodeSuccess(payload) {
        this.payload = payload;
        this.type = CustomEmailHandlerActionTypes.VerifyPasswordResetCodeSuccess;
    }
    return VerifyPasswordResetCodeSuccess;
}());

var customEmailHandler_actions = /*#__PURE__*/Object.freeze({
    CustomEmailHandlerActionTypes: CustomEmailHandlerActionTypes,
    CheckActionCode: CheckActionCode,
    CheckActionCodeError: CheckActionCodeError,
    CheckActionCodeSuccess: CheckActionCodeSuccess,
    RecoverEmail: RecoverEmail,
    RecoverEmailError: RecoverEmailError,
    RecoverEmailSuccess: RecoverEmailSuccess,
    ResetPassword: ResetPassword,
    ResetPasswordError: ResetPasswordError,
    ResetPasswordSuccess: ResetPasswordSuccess,
    VerifyEmailAddress: VerifyEmailAddress,
    VerifyEmailAddressError: VerifyEmailAddressError,
    VerifyEmailAddressSuccess: VerifyEmailAddressSuccess,
    VerifyPasswordResetCode: VerifyPasswordResetCode,
    VerifyPasswordResetCodeError: VerifyPasswordResetCodeError,
    VerifyPasswordResetCodeSuccess: VerifyPasswordResetCodeSuccess
});

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @enum {string} */
var PasswordManagementActionTypes = {
    ChangePasswordRequest: '[Auth/Password] Change Password Request',
    ChangePasswordError: '[Auth/Password] Change Password Error',
    ChangePasswordSuccess: '[Auth/Password] Change Password Success',
    ResetPasswordStatus: '[Auth/Password] Reset Change Password Status',
    ResetPasswordRequest: '[Auth/Password] Reset Password Request',
    ResetPasswordRequestError: '[Auth/Password] Reset Password Request Error',
    ResetPasswordRequestSuccess: '[Auth/Password] Reset Password Request Success',
};
var ChangePasswordRequest = /** @class */ (function () {
    function ChangePasswordRequest(payload) {
        this.payload = payload;
        this.type = PasswordManagementActionTypes.ChangePasswordRequest;
    }
    return ChangePasswordRequest;
}());
var ChangePasswordError = /** @class */ (function () {
    function ChangePasswordError(payload) {
        this.payload = payload;
        this.type = PasswordManagementActionTypes.ChangePasswordError;
    }
    return ChangePasswordError;
}());
var ChangePasswordSuccess = /** @class */ (function () {
    function ChangePasswordSuccess() {
        this.type = PasswordManagementActionTypes.ChangePasswordSuccess;
    }
    return ChangePasswordSuccess;
}());
var ResetPasswordStatus = /** @class */ (function () {
    function ResetPasswordStatus() {
        this.type = PasswordManagementActionTypes.ResetPasswordStatus;
    }
    return ResetPasswordStatus;
}());
var ResetPasswordRequest = /** @class */ (function () {
    function ResetPasswordRequest(payload) {
        this.payload = payload;
        this.type = PasswordManagementActionTypes.ResetPasswordRequest;
    }
    return ResetPasswordRequest;
}());
var ResetPasswordRequestError = /** @class */ (function () {
    function ResetPasswordRequestError(payload) {
        this.payload = payload;
        this.type = PasswordManagementActionTypes.ResetPasswordRequestError;
    }
    return ResetPasswordRequestError;
}());
var ResetPasswordRequestSuccess = /** @class */ (function () {
    function ResetPasswordRequestSuccess() {
        this.type = PasswordManagementActionTypes.ResetPasswordRequestSuccess;
    }
    return ResetPasswordRequestSuccess;
}());

var passwordManagement_actions = /*#__PURE__*/Object.freeze({
    PasswordManagementActionTypes: PasswordManagementActionTypes,
    ChangePasswordRequest: ChangePasswordRequest,
    ChangePasswordError: ChangePasswordError,
    ChangePasswordSuccess: ChangePasswordSuccess,
    ResetPasswordStatus: ResetPasswordStatus,
    ResetPasswordRequest: ResetPasswordRequest,
    ResetPasswordRequestError: ResetPasswordRequestError,
    ResetPasswordRequestSuccess: ResetPasswordRequestSuccess
});

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @enum {string} */
var ProvidersManagementActionTypes = {
    CodeSent: '[Auth/Providers] Code Sent',
    LinkCredentialAccount: '[Auth/Providers] Link Credential Account',
    LinkFacebookAccount: '[Auth/Providers] Link Facebook Account',
    LinkGoogleAccount: '[Auth/Providers] Link Google Account',
    LinkError: '[Auth/Providers] Link Error',
    LinkSuccess: '[Auth/Providers] Link Success',
    SetProviders: '[Auth/Providers] Set Providers',
    UnlinkCredentialAccount: '[Auth/Providers] Unlink Credential Account',
    UnlinkFacebookAccount: '[Auth/Providers] Unlink Facebook Account',
    UnlinkGoogleAccount: '[Auth/Providers] Unlink Google Account',
    UnlinkError: '[Auth/Providers] Unlink Error',
    UnlinkSuccess: '[Auth/Providers] Unlink Success',
    SendPhoneNumberCode: '[Auth] Send Phone Number Code',
    UnlinkPhoneNumber: '[Auth] Unlink Phone Number',
    VerifyPhoneNumber: '[Auth] Verify Phone',
};
var LinkCredentialAccount = /** @class */ (function () {
    function LinkCredentialAccount(payload) {
        this.payload = payload;
        this.type = ProvidersManagementActionTypes.LinkCredentialAccount;
    }
    return LinkCredentialAccount;
}());
var LinkFacebookAccount = /** @class */ (function () {
    function LinkFacebookAccount() {
        this.type = ProvidersManagementActionTypes.LinkFacebookAccount;
    }
    return LinkFacebookAccount;
}());
var LinkGoogleAccount = /** @class */ (function () {
    function LinkGoogleAccount() {
        this.type = ProvidersManagementActionTypes.LinkGoogleAccount;
    }
    return LinkGoogleAccount;
}());
var VerifyPhoneNumber = /** @class */ (function () {
    function VerifyPhoneNumber(payload) {
        this.payload = payload;
        this.type = ProvidersManagementActionTypes.VerifyPhoneNumber;
    }
    return VerifyPhoneNumber;
}());
var LinkSuccess = /** @class */ (function () {
    function LinkSuccess(payload) {
        this.payload = payload;
        this.type = ProvidersManagementActionTypes.LinkSuccess;
    }
    return LinkSuccess;
}());
var LinkError = /** @class */ (function () {
    function LinkError(payload) {
        this.payload = payload;
        this.type = ProvidersManagementActionTypes.LinkError;
    }
    return LinkError;
}());
var UnlinkSuccess = /** @class */ (function () {
    function UnlinkSuccess(payload) {
        this.payload = payload;
        this.type = ProvidersManagementActionTypes.UnlinkSuccess;
    }
    return UnlinkSuccess;
}());
var UnlinkError = /** @class */ (function () {
    function UnlinkError(payload) {
        this.payload = payload;
        this.type = ProvidersManagementActionTypes.UnlinkError;
    }
    return UnlinkError;
}());
var SendPhoneNumberCode = /** @class */ (function () {
    function SendPhoneNumberCode(payload) {
        this.payload = payload;
        this.type = ProvidersManagementActionTypes.SendPhoneNumberCode;
    }
    return SendPhoneNumberCode;
}());
var UnlinkFacebookAccount = /** @class */ (function () {
    function UnlinkFacebookAccount() {
        this.type = ProvidersManagementActionTypes.UnlinkFacebookAccount;
    }
    return UnlinkFacebookAccount;
}());
var UnlinkGoogleAccount = /** @class */ (function () {
    function UnlinkGoogleAccount() {
        this.type = ProvidersManagementActionTypes.UnlinkGoogleAccount;
    }
    return UnlinkGoogleAccount;
}());
var UnlinkCredentialAccount = /** @class */ (function () {
    function UnlinkCredentialAccount() {
        this.type = ProvidersManagementActionTypes.UnlinkCredentialAccount;
    }
    return UnlinkCredentialAccount;
}());
var SetProviders = /** @class */ (function () {
    function SetProviders(payload) {
        this.payload = payload;
        this.type = ProvidersManagementActionTypes.SetProviders;
    }
    return SetProviders;
}());
var CodeSent = /** @class */ (function () {
    function CodeSent() {
        this.type = ProvidersManagementActionTypes.CodeSent;
    }
    return CodeSent;
}());
var UnlinkPhoneNumber = /** @class */ (function () {
    function UnlinkPhoneNumber() {
        this.type = ProvidersManagementActionTypes.UnlinkPhoneNumber;
    }
    return UnlinkPhoneNumber;
}());

var providersManagement_actions = /*#__PURE__*/Object.freeze({
    ProvidersManagementActionTypes: ProvidersManagementActionTypes,
    LinkCredentialAccount: LinkCredentialAccount,
    LinkFacebookAccount: LinkFacebookAccount,
    LinkGoogleAccount: LinkGoogleAccount,
    VerifyPhoneNumber: VerifyPhoneNumber,
    LinkSuccess: LinkSuccess,
    LinkError: LinkError,
    UnlinkSuccess: UnlinkSuccess,
    UnlinkError: UnlinkError,
    SendPhoneNumberCode: SendPhoneNumberCode,
    UnlinkFacebookAccount: UnlinkFacebookAccount,
    UnlinkGoogleAccount: UnlinkGoogleAccount,
    UnlinkCredentialAccount: UnlinkCredentialAccount,
    SetProviders: SetProviders,
    CodeSent: CodeSent,
    UnlinkPhoneNumber: UnlinkPhoneNumber
});

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @enum {string} */
var AuthActionTypes = {
    Authenticated: '[Auth] Authenticated',
    AuthError: '[Auth] Error',
    CredentialsLogin: '[Auth] Credentials Login Attempt',
    CredentialsReAuthentication: '[Auth] Credentials ReAuthentication attempt',
    CredentialsRegistration: '[Auth] Credentials Registration Attempt',
    DeleteAccount: '[Auth] Delete Account',
    DeleteAccountSuccess: '[Auth] Delete Account Success',
    DeleteAccountError: '[Auth] Delete Account Error',
    FacebookLogin: '[Auth] Facebook Login Attempt',
    FacebookReAuthentication: '[Auth] Facebook ReAuthentication Attempt',
    FacebookRegistration: '[Auth] Facebook Registration Attempt',
    GetUser: '[Auth] Get User',
    GoogleLogin: '[Auth] Google Login Attempt',
    GoogleReAuthentication: '[Auth] Google ReAuthentication Attempt',
    GoogleRegistration: '[Auth] Google Registration Attempt',
    Logout: '[Auth] Logout',
    NotAuthenticated: '[Auth] Not Authenticated',
    SendVerificationEmail: '[Auth] Send Verification Email',
    ReAuthenticationError: '[Auth] ReAuthentication Error',
    ReAuthenticationSuccess: '[Auth] ReAuthentication Success',
    RefreshToken: '[Auth] ReFresh Token',
    RegistrationSuccess: '[Auth] Registration Success',
    ResetAuthState: '[Auth] Reset State',
    VerificationEmailError: '[Auth] Verification Email Error',
    VerificationEmailSent: '[Auth] Verification Email Sent',
};
var GetUser = /** @class */ (function () {
    function GetUser(payload) {
        this.payload = payload;
        this.type = AuthActionTypes.GetUser;
    }
    return GetUser;
}());
var Authenticated = /** @class */ (function () {
    function Authenticated(payload) {
        this.payload = payload;
        this.type = AuthActionTypes.Authenticated;
    }
    return Authenticated;
}());
var NotAuthenticated = /** @class */ (function () {
    function NotAuthenticated(payload) {
        this.payload = payload;
        this.type = AuthActionTypes.NotAuthenticated;
    }
    return NotAuthenticated;
}());
var AuthError = /** @class */ (function () {
    function AuthError(payload) {
        this.payload = payload;
        this.type = AuthActionTypes.AuthError;
    }
    return AuthError;
}());
var GoogleRegistration = /** @class */ (function () {
    function GoogleRegistration(payload) {
        this.payload = payload;
        this.type = AuthActionTypes.GoogleRegistration;
    }
    return GoogleRegistration;
}());
var FacebookRegistration = /** @class */ (function () {
    function FacebookRegistration(payload) {
        this.payload = payload;
        this.type = AuthActionTypes.FacebookRegistration;
    }
    return FacebookRegistration;
}());
var CredentialsRegistration = /** @class */ (function () {
    function CredentialsRegistration(payload) {
        this.payload = payload;
        this.type = AuthActionTypes.CredentialsRegistration;
    }
    return CredentialsRegistration;
}());
var RegistrationSuccess = /** @class */ (function () {
    function RegistrationSuccess(payload) {
        this.payload = payload;
        this.type = AuthActionTypes.RegistrationSuccess;
    }
    return RegistrationSuccess;
}());
var Logout = /** @class */ (function () {
    function Logout(payload) {
        this.payload = payload;
        this.type = AuthActionTypes.Logout;
    }
    return Logout;
}());
var GoogleLogin = /** @class */ (function () {
    function GoogleLogin(payload) {
        this.payload = payload;
        this.type = AuthActionTypes.GoogleLogin;
    }
    return GoogleLogin;
}());
var FacebookLogin = /** @class */ (function () {
    function FacebookLogin(payload) {
        this.payload = payload;
        this.type = AuthActionTypes.FacebookLogin;
    }
    return FacebookLogin;
}());
var CredentialsLogin = /** @class */ (function () {
    function CredentialsLogin(email, password, remember) {
        this.email = email;
        this.password = password;
        this.remember = remember;
        this.type = AuthActionTypes.CredentialsLogin;
    }
    return CredentialsLogin;
}());
var GoogleReAuthentication = /** @class */ (function () {
    function GoogleReAuthentication(payload) {
        this.payload = payload;
        this.type = AuthActionTypes.GoogleReAuthentication;
    }
    return GoogleReAuthentication;
}());
var FacebookReAuthentication = /** @class */ (function () {
    function FacebookReAuthentication(payload) {
        this.payload = payload;
        this.type = AuthActionTypes.FacebookReAuthentication;
    }
    return FacebookReAuthentication;
}());
var CredentialsReAuthentication = /** @class */ (function () {
    function CredentialsReAuthentication(email, password, remember) {
        this.email = email;
        this.password = password;
        this.remember = remember;
        this.type = AuthActionTypes.CredentialsReAuthentication;
    }
    return CredentialsReAuthentication;
}());
var ReAuthenticationSuccess = /** @class */ (function () {
    function ReAuthenticationSuccess() {
        this.type = AuthActionTypes.ReAuthenticationSuccess;
    }
    return ReAuthenticationSuccess;
}());
var ReAuthenticationError = /** @class */ (function () {
    function ReAuthenticationError(payload) {
        this.payload = payload;
        this.type = AuthActionTypes.ReAuthenticationError;
    }
    return ReAuthenticationError;
}());
var SendVerificationEmail = /** @class */ (function () {
    function SendVerificationEmail(payload) {
        this.payload = payload;
        this.type = AuthActionTypes.SendVerificationEmail;
    }
    return SendVerificationEmail;
}());
var VerificationEmailError = /** @class */ (function () {
    function VerificationEmailError(payload) {
        this.payload = payload;
        this.type = AuthActionTypes.VerificationEmailError;
    }
    return VerificationEmailError;
}());
var VerificationEmailSent = /** @class */ (function () {
    function VerificationEmailSent() {
        this.type = AuthActionTypes.VerificationEmailSent;
    }
    return VerificationEmailSent;
}());
var DeleteAccount = /** @class */ (function () {
    function DeleteAccount() {
        this.type = AuthActionTypes.DeleteAccount;
    }
    return DeleteAccount;
}());
var DeleteAccountSuccess = /** @class */ (function () {
    function DeleteAccountSuccess() {
        this.type = AuthActionTypes.DeleteAccountSuccess;
    }
    return DeleteAccountSuccess;
}());
var DeleteAccountError = /** @class */ (function () {
    function DeleteAccountError(payload) {
        this.payload = payload;
        this.type = AuthActionTypes.DeleteAccountError;
    }
    return DeleteAccountError;
}());
var ResetAuthState = /** @class */ (function () {
    function ResetAuthState() {
        this.type = AuthActionTypes.ResetAuthState;
    }
    return ResetAuthState;
}());
var RefreshToken = /** @class */ (function () {
    function RefreshToken() {
        this.type = AuthActionTypes.RefreshToken;
    }
    return RefreshToken;
}());

var auth_actions = /*#__PURE__*/Object.freeze({
    AuthActionTypes: AuthActionTypes,
    GetUser: GetUser,
    Authenticated: Authenticated,
    NotAuthenticated: NotAuthenticated,
    AuthError: AuthError,
    GoogleRegistration: GoogleRegistration,
    FacebookRegistration: FacebookRegistration,
    CredentialsRegistration: CredentialsRegistration,
    RegistrationSuccess: RegistrationSuccess,
    Logout: Logout,
    GoogleLogin: GoogleLogin,
    FacebookLogin: FacebookLogin,
    CredentialsLogin: CredentialsLogin,
    GoogleReAuthentication: GoogleReAuthentication,
    FacebookReAuthentication: FacebookReAuthentication,
    CredentialsReAuthentication: CredentialsReAuthentication,
    ReAuthenticationSuccess: ReAuthenticationSuccess,
    ReAuthenticationError: ReAuthenticationError,
    SendVerificationEmail: SendVerificationEmail,
    VerificationEmailError: VerificationEmailError,
    VerificationEmailSent: VerificationEmailSent,
    DeleteAccount: DeleteAccount,
    DeleteAccountSuccess: DeleteAccountSuccess,
    DeleteAccountError: DeleteAccountError,
    ResetAuthState: ResetAuthState,
    RefreshToken: RefreshToken
});

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var defaultState = {
    loggedIn: false,
    user: null,
    loading: true,
    error: null,
    success: false
};
/// Reducer function
/**
 * @param {?=} state
 * @param {?=} action
 * @return {?}
 */
function reducer(state, action) {
    if (state === void 0) { state = defaultState; }
    switch (action.type) {
        case AuthActionTypes.GetUser:
            return __assign({}, state, { loading: true, success: false });
        case AuthActionTypes.Authenticated:
        case AuthActionTypes.RegistrationSuccess:
            return __assign({}, state, { user: action.payload.user, loading: false, loggedIn: true, success: false });
        case AuthActionTypes.NotAuthenticated:
            return __assign({}, state, defaultState, { loading: false, loggedIn: false, success: false });
        case AuthActionTypes.GoogleLogin:
        case AuthActionTypes.FacebookLogin:
        case AuthActionTypes.GoogleRegistration:
        case AuthActionTypes.FacebookRegistration:
        case AuthActionTypes.CredentialsLogin:
        case AuthActionTypes.CredentialsRegistration:
        case AuthActionTypes.FacebookReAuthentication:
        case AuthActionTypes.CredentialsReAuthentication:
        case AuthActionTypes.GoogleReAuthentication:
            return __assign({}, state, { loading: true, success: false });
        case AuthActionTypes.ResetAuthState:
            return __assign({}, state, { loading: false, success: false, error: null });
        case AuthActionTypes.AuthError:
        case AuthActionTypes.ReAuthenticationError:
            return __assign({}, state, { loading: false, success: false, error: action.payload });
        case AuthActionTypes.ReAuthenticationSuccess:
            return __assign({}, state, { loading: false, error: null, success: true });
        case AuthActionTypes.Logout:
            return __assign({}, state, { loading: true });
        case AuthActionTypes.DeleteAccount:
            return __assign({}, state, { loading: true, success: true, error: null });
        case AuthActionTypes.DeleteAccountError:
            return __assign({}, state, { loading: false, success: false, error: action.payload });
        case AuthActionTypes.DeleteAccountSuccess:
            return __assign({}, state, { loading: false, loggedIn: false, success: true, error: null, user: null });
        case CustomEmailHandlerActionTypes.VerifyEmailAddressSuccess:
            return __assign({}, state, { user: __assign({}, state.user, { emailVerified: true }) });
        default:
            return state;
    }
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var initialState = (/** @type {?} */ ({
    loading: false,
    success: false,
    error: null
}));
/**
 * @param {?=} state
 * @param {?=} action
 * @return {?}
 */
function reducer$1(state, action) {
    if (state === void 0) { state = initialState; }
    switch (action.type) {
        case PasswordManagementActionTypes.ResetPasswordRequest:
        case PasswordManagementActionTypes.ChangePasswordRequest: {
            return __assign({}, state, { loading: true, success: false, error: null });
        }
        case PasswordManagementActionTypes.ResetPasswordRequestError:
        case PasswordManagementActionTypes.ChangePasswordError: {
            return __assign({}, state, { loading: false, success: false, error: action.payload });
        }
        case PasswordManagementActionTypes.ResetPasswordRequestSuccess:
        case PasswordManagementActionTypes.ChangePasswordSuccess: {
            return __assign({}, state, { loading: false, success: true, error: null });
        }
        case PasswordManagementActionTypes.ResetPasswordStatus: {
            return __assign({}, state, { loading: false, success: false, error: null });
        }
        default:
            return state;
    }
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var initialState$1 = (/** @type {?} */ ({
    loading: false,
    success: false,
    providers: {
        facebook: false,
        google: false,
        phone: false,
        password: false
    },
    error: null
}));
/**
 * @param {?=} state
 * @param {?=} action
 * @return {?}
 */
function reducer$2(state, action) {
    if (state === void 0) { state = initialState$1; }
    var _a, _b;
    switch (action.type) {
        case ProvidersManagementActionTypes.SetProviders:
            return __assign({}, state, { providers: __assign({}, state.providers, action.payload) });
        case ProvidersManagementActionTypes.LinkCredentialAccount:
        case ProvidersManagementActionTypes.LinkFacebookAccount:
        case ProvidersManagementActionTypes.LinkGoogleAccount:
        case ProvidersManagementActionTypes.UnlinkCredentialAccount:
        case ProvidersManagementActionTypes.UnlinkGoogleAccount:
        case ProvidersManagementActionTypes.UnlinkFacebookAccount:
            return __assign({}, state, { success: false, error: null, loading: true });
        case ProvidersManagementActionTypes.LinkSuccess:
            return __assign({}, state, { providers: __assign({}, state.providers, (_a = {}, _a[action.payload.provider] = true, _a)), success: true, error: null, loading: false });
        case ProvidersManagementActionTypes.UnlinkSuccess:
            return __assign({}, state, { providers: __assign({}, state.providers, (_b = {}, _b[action.payload.provider] = false, _b)), success: true, error: null, loading: false });
        case ProvidersManagementActionTypes.LinkError:
        case ProvidersManagementActionTypes.UnlinkError:
            return __assign({}, state, { success: false, error: action.payload, loading: false });
        default:
            return state;
    }
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var initialRequestStatus = {
    loading: false,
    success: false,
    error: null
};
/** @type {?} */
var initialState$2 = (/** @type {?} */ ({
    emailVerified: __assign({}, initialRequestStatus),
    passwordResetCode: __assign({}, initialRequestStatus),
    resetPassword: __assign({}, initialRequestStatus),
    checkCode: __assign({}, initialRequestStatus),
    recoverEmail: __assign({}, initialRequestStatus)
}));
/**
 * @param {?=} state
 * @param {?=} action
 * @return {?}
 */
function reducer$3(state, action) {
    if (state === void 0) { state = initialState$2; }
    switch (action.type) {
        case CustomEmailHandlerActionTypes.VerifyEmailAddress: {
            return __assign({}, state, { emailVerified: { loading: true, success: false, error: null } });
        }
        case CustomEmailHandlerActionTypes.VerifyEmailAddressError: {
            return __assign({}, state, { emailVerified: { loading: false, success: false, error: action.payload } });
        }
        case CustomEmailHandlerActionTypes.VerifyEmailAddressSuccess: {
            return __assign({}, state, { emailVerified: { loading: false, success: true, error: null } });
        }
        case CustomEmailHandlerActionTypes.VerifyPasswordResetCode: {
            return __assign({}, state, { passwordResetCode: { email: null, loading: true, success: false, error: null } });
        }
        case CustomEmailHandlerActionTypes.VerifyPasswordResetCodeError: {
            return __assign({}, state, { passwordResetCode: { email: null, loading: false, success: false, error: action.payload } });
        }
        case CustomEmailHandlerActionTypes.VerifyPasswordResetCodeSuccess: {
            return __assign({}, state, { passwordResetCode: { email: action.payload.email, loading: false, success: true, error: null } });
        }
        case CustomEmailHandlerActionTypes.CheckActionCode: {
            return __assign({}, state, { checkCode: { loading: true, success: false, error: null } });
        }
        case CustomEmailHandlerActionTypes.CheckActionCodeError: {
            return __assign({}, state, { checkCode: { loading: false, success: false, error: action.payload } });
        }
        case CustomEmailHandlerActionTypes.CheckActionCodeSuccess: {
            return __assign({}, state, { checkCode: { loading: false, success: true, error: null } });
        }
        case CustomEmailHandlerActionTypes.RecoverEmail: {
            return __assign({}, state, { recoverEmail: { loading: true, success: false, error: null } });
        }
        case CustomEmailHandlerActionTypes.RecoverEmailError: {
            return __assign({}, state, { recoverEmail: { loading: false, success: false, error: action.payload } });
        }
        case CustomEmailHandlerActionTypes.RecoverEmailSuccess: {
            return __assign({}, state, { recoverEmail: { loading: false, success: true, error: null } });
        }
        case CustomEmailHandlerActionTypes.ResetPassword: {
            return __assign({}, state, { resetPassword: { loading: true, success: false, error: null } });
        }
        case CustomEmailHandlerActionTypes.ResetPasswordError: {
            return __assign({}, state, { resetPassword: { loading: false, success: false, error: action.payload } });
        }
        case CustomEmailHandlerActionTypes.ResetPasswordSuccess: {
            return __assign({}, state, { resetPassword: { loading: false, success: true, error: null } });
        }
        default:
            return state;
    }
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var reducers = {
    user: reducer,
    changePassword: reducer$1,
    providers: reducer$2,
    customEmailHandler: reducer$3
};
/** @type {?} */
var getAuthState = createFeatureSelector('auth');
/** @type {?} */
var getUserState = createSelector(getAuthState, (/**
 * @param {?} state
 * @return {?}
 */
function (state) { return state.user; }));
/** @type {?} */
var isAuthLoading = createSelector(getAuthState, (/**
 * @param {?} state
 * @return {?}
 */
function (state) { return state.user.loading; }));
/** @type {?} */
var isUserLogged = createSelector(getAuthState, (/**
 * @param {?} state
 * @return {?}
 */
function (state) { return state.user.loggedIn && state.user.user && state.user.user.emailVerified; }));
/** @type {?} */
var getUser = createSelector(getAuthState, (/**
 * @param {?} state
 * @return {?}
 */
function (state) { return state.user.user; }));
/** @type {?} */
var getAuthError = createSelector(getAuthState, (/**
 * @param {?} state
 * @return {?}
 */
function (state) { return state.user.error; }));
/** @type {?} */
var isAuthSuccess = createSelector(getAuthState, (/**
 * @param {?} state
 * @return {?}
 */
function (state) { return state.user.success; }));
/** @type {?} */
var getChangePasswordStatus = createSelector(getAuthState, (/**
 * @param {?} state
 * @return {?}
 */
function (state) { return state.changePassword; }));
/** @type {?} */
var getUserProvidersState = createSelector(getAuthState, (/**
 * @param {?} state
 * @return {?}
 */
function (state) { return state.providers; }));
/** @type {?} */
var getUserProviders = createSelector(getAuthState, (/**
 * @param {?} state
 * @return {?}
 */
function (state) { return state.providers.providers; }));
/** @type {?} */
var getProvidersRequestStatus = createSelector(getAuthState, (/**
 * @param {?} state
 * @return {?}
 */
function (state) {
    return {
        loading: state.providers.loading,
        error: state.providers.error,
        success: state.providers.success
    };
}));
/** @type {?} */
var getCustomEmailHandlerRequestStatus = createSelector(getAuthState, (/**
 * @param {?} state
 * @return {?}
 */
function (state) {
    return {
        emailVerified: {
            loading: state.customEmailHandler.emailVerified.loading,
            error: state.customEmailHandler.emailVerified.error,
            success: state.customEmailHandler.emailVerified.success
        }
    };
}));
/** @type {?} */
var getEmailVerifiedStatus = createSelector(getAuthState, (/**
 * @param {?} state
 * @return {?}
 */
function (state) { return state.customEmailHandler.emailVerified; }));
/** @type {?} */
var getPasswordResetStatus = createSelector(getAuthState, (/**
 * @param {?} state
 * @return {?}
 */
function (state) { return state.customEmailHandler.resetPassword; }));
/** @type {?} */
var getVerifyResetPasswordProcedure = createSelector(getAuthState, (/**
 * @param {?} state
 * @return {?}
 */
function (state) { return state.customEmailHandler.passwordResetCode; }));
/** @type {?} */
var getEmailVerifiedError = createSelector(getAuthState, (/**
 * @param {?} state
 * @return {?}
 */
function (state) { return state.customEmailHandler.emailVerified.error; }));
/** @type {?} */
var isEmailVerifiedLoading = createSelector(getAuthState, (/**
 * @param {?} state
 * @return {?}
 */
function (state) { return state.customEmailHandler.emailVerified.loading; }));
/** @type {?} */
var getPasswordResetCodeError = createSelector(getAuthState, (/**
 * @param {?} state
 * @return {?}
 */
function (state) { return state.customEmailHandler.passwordResetCode.error; }));
/** @type {?} */
var isPasswordResetCodeLoading = createSelector(getAuthState, (/**
 * @param {?} state
 * @return {?}
 */
function (state) { return state.customEmailHandler.passwordResetCode.loading; }));
/** @type {?} */
var getPasswordResetCodeEmail = createSelector(getAuthState, (/**
 * @param {?} state
 * @return {?}
 */
function (state) { return state.customEmailHandler.passwordResetCode.email; }));
/** @type {?} */
var getResetPasswordError = createSelector(getAuthState, (/**
 * @param {?} state
 * @return {?}
 */
function (state) { return state.customEmailHandler.resetPassword.error; }));
/** @type {?} */
var isResetPasswordLoading = createSelector(getAuthState, (/**
 * @param {?} state
 * @return {?}
 */
function (state) { return state.customEmailHandler.resetPassword.loading; }));
/** @type {?} */
var getCheckCodeError = createSelector(getAuthState, (/**
 * @param {?} state
 * @return {?}
 */
function (state) { return state.customEmailHandler.checkCode.error; }));
/** @type {?} */
var isCheckCodeLoading = createSelector(getAuthState, (/**
 * @param {?} state
 * @return {?}
 */
function (state) { return state.customEmailHandler.checkCode.loading; }));
/** @type {?} */
var getRecoverEmailError = createSelector(getAuthState, (/**
 * @param {?} state
 * @return {?}
 */
function (state) { return state.customEmailHandler.recoverEmail.error; }));
/** @type {?} */
var isRecoverEmailLoading = createSelector(getAuthState, (/**
 * @param {?} state
 * @return {?}
 */
function (state) { return state.customEmailHandler.recoverEmail.loading; }));
/** @type {?} */
var getResetPasswordOrCodeError = createSelector(getAuthState, (/**
 * @param {?} state
 * @return {?}
 */
function (state) { return state.customEmailHandler.resetPassword.error || state.customEmailHandler.passwordResetCode.error; }));
/** @type {?} */
var getResetPasswordSuccess = createSelector(getAuthState, (/**
 * @param {?} state
 * @return {?}
 */
function (state) { return state.customEmailHandler.resetPassword.success; }));
/** @type {?} */
var isResetPasswordOrCodeLoading = createSelector(getAuthState, (/**
 * @param {?} state
 * @return {?}
 */
function (state) { return state.customEmailHandler.resetPassword.loading || state.customEmailHandler.passwordResetCode.loading; }));
/** @type {?} */
var getRecoverEmailOrCheckCodeError = createSelector(getAuthState, (/**
 * @param {?} state
 * @return {?}
 */
function (state) { return state.customEmailHandler.recoverEmail.error || state.customEmailHandler.checkCode.error; }));
/** @type {?} */
var isRecoverEmailOrCheckCodeLoading = createSelector(getAuthState, (/**
 * @param {?} state
 * @return {?}
 */
function (state) { return state.customEmailHandler.recoverEmail.loading || state.customEmailHandler.checkCode.loading; }));

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var FirebaseNgrxUserManagementService = /** @class */ (function () {
    function FirebaseNgrxUserManagementService() {
    }
    FirebaseNgrxUserManagementService.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    FirebaseNgrxUserManagementService.ctorParameters = function () { return []; };
    /** @nocollapse */ FirebaseNgrxUserManagementService.ngInjectableDef = defineInjectable({ factory: function FirebaseNgrxUserManagementService_Factory() { return new FirebaseNgrxUserManagementService(); }, token: FirebaseNgrxUserManagementService, providedIn: "root" });
    return FirebaseNgrxUserManagementService;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var PROVIDERS_MAP = {};
PROVIDERS_MAP[auth.FacebookAuthProvider.FACEBOOK_SIGN_IN_METHOD] = 'facebook';
PROVIDERS_MAP[auth.GoogleAuthProvider.GOOGLE_SIGN_IN_METHOD] = 'google';
PROVIDERS_MAP[auth.EmailAuthProvider.EMAIL_PASSWORD_SIGN_IN_METHOD] = 'password';
PROVIDERS_MAP[auth.PhoneAuthProvider.PHONE_SIGN_IN_METHOD] = 'phone';
var LoginEffects = /** @class */ (function () {
    function LoginEffects(actions$, afAuth) {
        var _this = this;
        this.actions$ = actions$;
        this.afAuth = afAuth;
        this.getUser = this.actions$.pipe(ofType(AuthActionTypes.GetUser), map((/**
         * @param {?} action
         * @return {?}
         */
        function (action) { return action.payload; })), exhaustMap((/**
         * @param {?} payload
         * @return {?}
         */
        function (payload) { return _this.afAuth.authState.pipe(take(1), switchMap((/**
         * @param {?} authData
         * @return {?}
         */
        function (authData) {
            console.debug(authData);
            if (authData) {
                /// User logged in
                console.debug('USER', authData);
                return zip(from(authData.getIdToken(true))).pipe(switchMap((/**
                 * @param {?} res
                 * @return {?}
                 */
                function (res) {
                    console.debug('providers found', authData.providerData);
                    /** @type {?} */
                    var providers = authData.providerData.reduce((/**
                     * @param {?} prev
                     * @param {?} current
                     * @return {?}
                     */
                    function (prev, current) {
                        /** @type {?} */
                        var key = PROVIDERS_MAP[current.providerId];
                        if (key) {
                            prev[key] = true;
                        }
                        return prev;
                    }), {});
                    console.debug(providers, authData.providerData.map((/**
                     * @param {?} p
                     * @return {?}
                     */
                    function (p) { return p.providerId; })));
                    /** @type {?} */
                    var user = new User(authData.uid, authData.displayName, authData.email, authData.phoneNumber, authData.photoURL, authData.emailVerified);
                    return from([new SetProviders(providers), new Authenticated({ user: user })]);
                })));
            }
            else {
                return of(new NotAuthenticated());
            }
        }))); })));
        this.googleLogin = this.actions$.pipe(ofType(AuthActionTypes.GoogleLogin), map((/**
         * @param {?} action
         * @return {?}
         */
        function (action) { return action.payload; })), exhaustMap((/**
         * @param {?} payload
         * @return {?}
         */
        function (payload) {
            return from(_this.doGoogleLogin()).pipe(map((/**
             * @param {?} credential
             * @return {?}
             */
            function (credential) {
                // successful login
                return new GetUser();
            })), catchError((/**
             * @param {?} error
             * @return {?}
             */
            function (error) { return of(new AuthError(error)); })));
        })));
        this.facebookLogin = this.actions$.pipe(ofType(AuthActionTypes.FacebookLogin), map((/**
         * @param {?} action
         * @return {?}
         */
        function (action) { return action.payload; })), exhaustMap((/**
         * @param {?} payload
         * @return {?}
         */
        function (payload) {
            return from(_this.doFacebookLogin()).pipe(map((/**
             * @param {?} credential
             * @return {?}
             */
            function (credential) {
                // successful login
                return new GetUser();
            })), catchError((/**
             * @param {?} error
             * @return {?}
             */
            function (error) { return of(new AuthError(error)); })));
        })));
        this.loginWithCredentials = this.actions$.pipe(ofType(AuthActionTypes.CredentialsLogin), map((/**
         * @param {?} action
         * @return {?}
         */
        function (action) {
            return {
                email: action.email,
                password: action.password,
                remember: (action.remember) ? action.remember : false
            };
        })), exhaustMap((/**
         * @param {?} credentials
         * @return {?}
         */
        function (credentials) {
            return from(_this.doLoginWithCredentials(credentials)).pipe(map((/**
             * @param {?} p
             * @return {?}
             */
            function (p) {
                // successful login
                return new GetUser();
            })), catchError((/**
             * @param {?} error
             * @return {?}
             */
            function (error) { return of(new AuthError(error)); })));
        })));
        this.logout = this.actions$.pipe(ofType(AuthActionTypes.Logout), map((/**
         * @param {?} action
         * @return {?}
         */
        function (action) { return action.payload; })), exhaustMap((/**
         * @param {?} payload
         * @return {?}
         */
        function (payload) {
            return from(_this.afAuth.auth.signOut());
        })), map((/**
         * @param {?} authData
         * @return {?}
         */
        function (authData) {
            return new NotAuthenticated();
        })));
        this.onDeleteNotVerifiedAccount$ = this.actions$.pipe(ofType(AuthActionTypes.DeleteAccount), switchMap((/**
         * @return {?}
         */
        function () {
            return from(_this.afAuth.auth.currentUser.delete()).pipe(map((/**
             * @return {?}
             */
            function () { return new DeleteAccountSuccess(); })), catchError((/**
             * @param {?} error
             * @return {?}
             */
            function (error) { return of(new DeleteAccountError(error)); })));
        })));
        this.refreshToken$ = this.actions$.pipe(ofType(AuthActionTypes.RefreshToken), tap((/**
         * @param {?} action
         * @return {?}
         */
        function (action) { return _this.afAuth.auth.currentUser.getIdToken(true); })));
    }
    /**
     * @private
     * @return {?}
     */
    LoginEffects.prototype.doFacebookLogin = /**
     * @private
     * @return {?}
     */
    function () {
        /** @type {?} */
        var provider = new auth.FacebookAuthProvider();
        return this.afAuth.auth.signInWithPopup(provider);
    };
    /**
     * @private
     * @return {?}
     */
    LoginEffects.prototype.doGoogleLogin = /**
     * @private
     * @return {?}
     */
    function () {
        /** @type {?} */
        var provider = new auth.GoogleAuthProvider();
        provider.setCustomParameters({
            prompt: 'select_account'
        });
        return this.afAuth.auth.signInWithPopup(provider);
    };
    /**
     * @private
     * @param {?} credentials
     * @return {?}
     */
    LoginEffects.prototype.doLoginWithCredentials = /**
     * @private
     * @param {?} credentials
     * @return {?}
     */
    function (credentials) {
        var _this = this;
        if (credentials.remember) {
            return this.afAuth.auth.setPersistence(auth.Auth.Persistence.LOCAL).then((/**
             * @return {?}
             */
            function () {
                return _this.afAuth.auth.signInWithEmailAndPassword(credentials.email, credentials.password);
            }));
        }
        else {
            return this.afAuth.auth.setPersistence(auth.Auth.Persistence.SESSION).then((/**
             * @return {?}
             */
            function () {
                return _this.afAuth.auth.signInWithEmailAndPassword(credentials.email, credentials.password);
            }));
        }
    };
    LoginEffects.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    LoginEffects.ctorParameters = function () { return [
        { type: Actions },
        { type: AngularFireAuth }
    ]; };
    __decorate([
        Effect(),
        __metadata("design:type", Observable)
    ], LoginEffects.prototype, "getUser", void 0);
    __decorate([
        Effect(),
        __metadata("design:type", Observable)
    ], LoginEffects.prototype, "googleLogin", void 0);
    __decorate([
        Effect(),
        __metadata("design:type", Observable)
    ], LoginEffects.prototype, "facebookLogin", void 0);
    __decorate([
        Effect(),
        __metadata("design:type", Observable)
    ], LoginEffects.prototype, "loginWithCredentials", void 0);
    __decorate([
        Effect(),
        __metadata("design:type", Observable)
    ], LoginEffects.prototype, "logout", void 0);
    __decorate([
        Effect(),
        __metadata("design:type", Observable)
    ], LoginEffects.prototype, "onDeleteNotVerifiedAccount$", void 0);
    __decorate([
        Effect({ dispatch: false }),
        __metadata("design:type", Object)
    ], LoginEffects.prototype, "refreshToken$", void 0);
    return LoginEffects;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var RegistrationEffects = /** @class */ (function () {
    function RegistrationEffects(actions, afAuth) {
        var _this = this;
        this.actions = actions;
        this.afAuth = afAuth;
        this.googleSignUp = this.actions.pipe(ofType(AuthActionTypes.GoogleRegistration), map((/**
         * @param {?} action
         * @return {?}
         */
        function (action) { return action.payload; })), exhaustMap((/**
         * @param {?} payload
         * @return {?}
         */
        function (payload) {
            return from(_this.doGoogleRegistration()).pipe(switchMap((/**
             * @param {?} credential
             * @return {?}
             */
            function (credential) {
                console.debug('credential', credential);
                /** @type {?} */
                var authData = credential.user;
                /** @type {?} */
                var photoUrl = authData.photoURL;
                /** @type {?} */
                var user = new User(authData.uid, authData.displayName, authData.email, authData.phoneNumber, photoUrl, authData.emailVerified);
                return from([new SetProviders({ google: true }), new RegistrationSuccess({ user: user })]);
            })), catchError((/**
             * @param {?} error
             * @return {?}
             */
            function (error) { return of(new AuthError(error)); })));
        })));
        this.facebookSignUp = this.actions.pipe(ofType(AuthActionTypes.FacebookRegistration), map((/**
         * @param {?} action
         * @return {?}
         */
        function (action) { return action.payload; })), exhaustMap((/**
         * @param {?} payload
         * @return {?}
         */
        function (payload) {
            return from(_this.doFacebookRegistration()).pipe(switchMap((/**
             * @param {?} credential
             * @return {?}
             */
            function (credential) {
                console.debug('facebookSignUp', credential);
                /** @type {?} */
                var authData = credential.user;
                /** @type {?} */
                var photoUrl = authData.photoURL;
                console.log('PhotoUrl', photoUrl);
                /** @type {?} */
                var user = new User(authData.uid, authData.displayName, authData.email, authData.phoneNumber, photoUrl, authData.emailVerified);
                return from([new SetProviders({ facebook: true }), new RegistrationSuccess({ user: user })]);
            })), catchError((/**
             * @param {?} error
             * @return {?}
             */
            function (error) { return of(new AuthError(error)); })));
        })));
        this.signUpWithCredentials = this.actions.pipe(ofType(AuthActionTypes.CredentialsRegistration), map((/**
         * @param {?} action
         * @return {?}
         */
        function (action) {
            return {
                email: action.payload.email,
                password: action.payload.password
            };
        })), exhaustMap((/**
         * @param {?} credentials
         * @return {?}
         */
        function (credentials) {
            return from(_this.doSignUpWithCredentials(credentials)).pipe(map((/**
             * @param {?} credential
             * @return {?}
             */
            function (credential) {
                console.debug('doSignUpWithCredentials', credential);
                /** @type {?} */
                var authData = credential.user;
                /** @type {?} */
                var user = new User(authData.uid, authData.displayName, authData.email, authData.phoneNumber, authData.photoURL, authData.emailVerified);
                return new RegistrationSuccess({ user: user });
            })), catchError((/**
             * @param {?} error
             * @return {?}
             */
            function (error) { return of(new AuthError(error)); })));
        })));
        this.sendVerificationEmail$ = this.actions.pipe(ofType(AuthActionTypes.SendVerificationEmail), map((/**
         * @param {?} action
         * @return {?}
         */
        function (action) { return action.payload; })), exhaustMap((/**
         * @param {?} payload
         * @return {?}
         */
        function (payload) {
            return from(_this.afAuth.auth.currentUser.sendEmailVerification({ url: payload.redirectUrl })).pipe(map((/**
             * @param {?} p
             * @return {?}
             */
            function (p) {
                return new VerificationEmailSent();
            })), catchError((/**
             * @param {?} error
             * @return {?}
             */
            function (error) { return of(new VerificationEmailError(error)); })));
        })));
    }
    /**
     * @private
     * @return {?}
     */
    RegistrationEffects.prototype.doFacebookRegistration = /**
     * @private
     * @return {?}
     */
    function () {
        /** @type {?} */
        var provider = new auth.FacebookAuthProvider();
        return this.afAuth.auth.signInWithPopup(provider);
    };
    /**
     * @private
     * @return {?}
     */
    RegistrationEffects.prototype.doGoogleRegistration = /**
     * @private
     * @return {?}
     */
    function () {
        /** @type {?} */
        var provider = new auth.GoogleAuthProvider();
        provider.setCustomParameters({
            prompt: 'select_account'
        });
        return this.afAuth.auth.signInWithPopup(provider);
    };
    /**
     * @private
     * @param {?} credentials
     * @return {?}
     */
    RegistrationEffects.prototype.doSignUpWithCredentials = /**
     * @private
     * @param {?} credentials
     * @return {?}
     */
    function (credentials) {
        return this.afAuth.auth.createUserWithEmailAndPassword(credentials.email, credentials.password);
    };
    RegistrationEffects.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    RegistrationEffects.ctorParameters = function () { return [
        { type: Actions },
        { type: AngularFireAuth }
    ]; };
    __decorate([
        Effect(),
        __metadata("design:type", Observable)
    ], RegistrationEffects.prototype, "googleSignUp", void 0);
    __decorate([
        Effect(),
        __metadata("design:type", Observable)
    ], RegistrationEffects.prototype, "facebookSignUp", void 0);
    __decorate([
        Effect(),
        __metadata("design:type", Observable)
    ], RegistrationEffects.prototype, "signUpWithCredentials", void 0);
    __decorate([
        Effect(),
        __metadata("design:type", Observable)
    ], RegistrationEffects.prototype, "sendVerificationEmail$", void 0);
    return RegistrationEffects;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ReAuthenticationEffects = /** @class */ (function () {
    function ReAuthenticationEffects(actions, afAuth) {
        var _this = this;
        this.actions = actions;
        this.afAuth = afAuth;
        this.googleReAuthentication = this.actions.pipe(ofType(AuthActionTypes.GoogleReAuthentication), map((/**
         * @param {?} action
         * @return {?}
         */
        function (action) { return action.payload; })), exhaustMap((/**
         * @param {?} payload
         * @return {?}
         */
        function (payload) {
            return from(_this.doGoogleReAuthentication()).pipe(map((/**
             * @param {?} credential
             * @return {?}
             */
            function (credential) {
                // successful login
                return new ReAuthenticationSuccess();
            })), catchError((/**
             * @param {?} error
             * @return {?}
             */
            function (error) { return of(new ReAuthenticationError(error)); })));
        })));
        this.facebookReAuthentication = this.actions.pipe(ofType(AuthActionTypes.FacebookReAuthentication), map((/**
         * @param {?} action
         * @return {?}
         */
        function (action) { return action.payload; })), exhaustMap((/**
         * @param {?} payload
         * @return {?}
         */
        function (payload) {
            return from(_this.doFacebookReAuthentication()).pipe(map((/**
             * @param {?} credential
             * @return {?}
             */
            function (credential) {
                // successful login
                return new ReAuthenticationSuccess();
            })), catchError((/**
             * @param {?} error
             * @return {?}
             */
            function (error) { return of(new ReAuthenticationError(error)); })));
        })));
        this.reAuthenticateWithCredentials = this.actions.pipe(ofType(AuthActionTypes.CredentialsReAuthentication), map((/**
         * @param {?} action
         * @return {?}
         */
        function (action) {
            return {
                email: action.email,
                password: action.password
            };
        })), exhaustMap((/**
         * @param {?} credentials
         * @return {?}
         */
        function (credentials) {
            return from(_this.doReAuthenticationWithCredentials(credentials)).pipe(map((/**
             * @param {?} p
             * @return {?}
             */
            function (p) {
                // successful login
                return new ReAuthenticationSuccess();
            })), catchError((/**
             * @param {?} error
             * @return {?}
             */
            function (error) { return of(new ReAuthenticationError(error)); })));
        })));
    }
    /**
     * @private
     * @return {?}
     */
    ReAuthenticationEffects.prototype.doFacebookReAuthentication = /**
     * @private
     * @return {?}
     */
    function () {
        /** @type {?} */
        var provider = new auth.FacebookAuthProvider();
        return this.afAuth.auth.currentUser.reauthenticateWithPopup(provider);
    };
    /**
     * @private
     * @return {?}
     */
    ReAuthenticationEffects.prototype.doGoogleReAuthentication = /**
     * @private
     * @return {?}
     */
    function () {
        /** @type {?} */
        var provider = new auth.GoogleAuthProvider();
        return this.afAuth.auth.currentUser.reauthenticateWithPopup(provider);
    };
    /**
     * @private
     * @param {?} credentials
     * @return {?}
     */
    ReAuthenticationEffects.prototype.doReAuthenticationWithCredentials = /**
     * @private
     * @param {?} credentials
     * @return {?}
     */
    function (credentials) {
        /** @type {?} */
        var credential = auth.EmailAuthProvider.credential(credentials.email, credentials.password);
        return this.afAuth.auth.currentUser.reauthenticateAndRetrieveDataWithCredential(credential);
    };
    ReAuthenticationEffects.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    ReAuthenticationEffects.ctorParameters = function () { return [
        { type: Actions },
        { type: AngularFireAuth }
    ]; };
    __decorate([
        Effect(),
        __metadata("design:type", Observable)
    ], ReAuthenticationEffects.prototype, "googleReAuthentication", void 0);
    __decorate([
        Effect(),
        __metadata("design:type", Observable)
    ], ReAuthenticationEffects.prototype, "facebookReAuthentication", void 0);
    __decorate([
        Effect(),
        __metadata("design:type", Observable)
    ], ReAuthenticationEffects.prototype, "reAuthenticateWithCredentials", void 0);
    return ReAuthenticationEffects;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var EmailAuthProvider = auth.EmailAuthProvider;
var ProvidersManagementEffects = /** @class */ (function () {
    function ProvidersManagementEffects(actions$, afAuth) {
        var _this = this;
        this.actions$ = actions$;
        this.afAuth = afAuth;
        this.linkToGoogleAccount$ = this.actions$.pipe(ofType(ProvidersManagementActionTypes.LinkGoogleAccount), exhaustMap((/**
         * @param {?} actins
         * @return {?}
         */
        function (actins) {
            return from(_this.doLinkToGoogleProvider()).pipe(mapTo(new LinkSuccess({ provider: 'google' })), catchError((/**
             * @param {?} error
             * @return {?}
             */
            function (error) { return of(new LinkError(error)); })));
        })));
        this.linkToFacebookAccount$ = this.actions$.pipe(ofType(ProvidersManagementActionTypes.LinkFacebookAccount), exhaustMap((/**
         * @param {?} actions
         * @return {?}
         */
        function (actions) {
            return from(_this.doLinkToFacebookProvider()).pipe(mapTo(new LinkSuccess({ provider: 'facebook' })), catchError((/**
             * @param {?} error
             * @return {?}
             */
            function (error) { return of(new LinkError(error)); })));
        })));
        this.linkToCredentialsAccount$ = this.actions$.pipe(ofType(ProvidersManagementActionTypes.LinkCredentialAccount), map((/**
         * @param {?} action
         * @return {?}
         */
        function (action) { return action.payload; })), exhaustMap((/**
         * @param {?} payload
         * @return {?}
         */
        function (payload) {
            return from(_this.reAuthenticate().then((/**
             * @param {?} res
             * @return {?}
             */
            function (res) { return __awaiter(_this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.doLinkToCredentials(this.afAuth.auth.currentUser.email, payload.password)];
                        case 1:
                            _a.sent();
                            return [2 /*return*/];
                    }
                });
            }); }))).pipe(mapTo(new LinkSuccess({ provider: 'password' })), catchError((/**
             * @param {?} error
             * @return {?}
             */
            function (error) {
                if (error.code === 'auth/popup-blocked') {
                    return from(_this.reAuthenticateWithRedirect().then((/**
                     * @param {?} res
                     * @return {?}
                     */
                    function (res) { return __awaiter(_this, void 0, void 0, function () {
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0: return [4 /*yield*/, this.doLinkToCredentials(this.afAuth.auth.currentUser.email, payload.password)];
                                case 1:
                                    _a.sent();
                                    return [2 /*return*/];
                            }
                        });
                    }); }))).pipe(mapTo(new LinkSuccess({ provider: 'password' })), catchError((/**
                     * @param {?} error1
                     * @return {?}
                     */
                    function (error1) { return of(new LinkError(error1)); })));
                }
                else {
                    return of(new LinkError(error));
                }
            })));
        })));
        this.unlinkGoogleAccount$ = this.actions$.pipe(ofType(ProvidersManagementActionTypes.UnlinkGoogleAccount), exhaustMap((/**
         * @param {?} actions
         * @return {?}
         */
        function (actions) {
            return from(_this.doUnlinkToGoogleProvider()).pipe(mapTo(new UnlinkSuccess({ provider: 'google' })), catchError((/**
             * @param {?} error
             * @return {?}
             */
            function (error) { return of(new UnlinkError(error)); })));
        })));
        this.unlinkFacebookAccount$ = this.actions$.pipe(ofType(ProvidersManagementActionTypes.UnlinkFacebookAccount), exhaustMap((/**
         * @param {?} actions
         * @return {?}
         */
        function (actions) {
            return from(_this.doUnlinkToFacebookProvider()).pipe(mapTo(new UnlinkSuccess({ provider: 'facebook' })), catchError((/**
             * @param {?} error
             * @return {?}
             */
            function (error) { return of(new UnlinkError(error)); })));
        })));
        this.unlinkCredentialsAccount$ = this.actions$.pipe(ofType(ProvidersManagementActionTypes.UnlinkCredentialAccount), exhaustMap((/**
         * @param {?} action
         * @return {?}
         */
        function (action) {
            return from(_this.reAuthenticate().then((/**
             * @param {?} res
             * @return {?}
             */
            function (res) { return __awaiter(_this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.doUnlinkToCredentials()];
                        case 1:
                            _a.sent();
                            return [2 /*return*/];
                    }
                });
            }); }))).pipe(mapTo(new UnlinkSuccess({ provider: 'password' })), catchError((/**
             * @param {?} error
             * @return {?}
             */
            function (error) { return of(new UnlinkError(error)); })));
        })));
        this.unlinkPhone$ = this.actions$.pipe(ofType(ProvidersManagementActionTypes.UnlinkPhoneNumber), exhaustMap((/**
         * @param {?} action
         * @return {?}
         */
        function (action) {
            return from(_this.doUnlinkPhoneNumber()).pipe(mapTo(new UnlinkSuccess({ provider: 'phone' })), catchError((/**
             * @param {?} error
             * @return {?}
             */
            function (error) { return of(new UnlinkError(error)); })));
        })));
        this.sendCodeToPhone$ = this.actions$.pipe(ofType(ProvidersManagementActionTypes.SendPhoneNumberCode), map((/**
         * @param {?} action
         * @return {?}
         */
        function (action) { return action.payload; })), exhaustMap((/**
         * @param {?} payload
         * @return {?}
         */
        function (payload) {
            return from(((/**
             * @return {?}
             */
            function () {
                return _this.afAuth.auth.currentUser.linkWithPhoneNumber(payload.number, new auth.RecaptchaVerifier(payload.captchaContainerId, {
                    size: 'invisible',
                    callback: (/**
                     * @param {?} token
                     * @return {?}
                     */
                    function (token) {
                        console.debug('Captcha token', token);
                    })
                })).then((/**
                 * @param {?} confirmation
                 * @return {?}
                 */
                function (confirmation) {
                    _this.phoneNumberConfirmation = confirmation;
                }));
            }))()).pipe(mapTo(new CodeSent()), catchError((/**
             * @param {?} error
             * @return {?}
             */
            function (error) { return of(new LinkError(error)); })));
        })));
        this.verifyCode$ = this.actions$.pipe(ofType(ProvidersManagementActionTypes.VerifyPhoneNumber), map((/**
         * @param {?} action
         * @return {?}
         */
        function (action) { return action.payload; })), exhaustMap((/**
         * @param {?} payload
         * @return {?}
         */
        function (payload) {
            return from(_this.phoneNumberConfirmation.confirm(payload.code)).pipe(mapTo(new LinkSuccess({ provider: 'phone' })), catchError((/**
             * @param {?} error
             * @return {?}
             */
            function (error) { return of(new LinkError(error)); })));
        })));
    }
    /**
     * @private
     * @return {?}
     */
    ProvidersManagementEffects.prototype.doLinkToGoogleProvider = /**
     * @private
     * @return {?}
     */
    function () {
        /** @type {?} */
        var provider = new auth.GoogleAuthProvider();
        return this.afAuth.auth.currentUser.linkWithPopup(provider);
    };
    /**
     * @private
     * @return {?}
     */
    ProvidersManagementEffects.prototype.doUnlinkToGoogleProvider = /**
     * @private
     * @return {?}
     */
    function () {
        /** @type {?} */
        var provider = new auth.GoogleAuthProvider();
        return this.afAuth.auth.currentUser.unlink(provider.providerId);
    };
    /**
     * @private
     * @return {?}
     */
    ProvidersManagementEffects.prototype.doLinkToFacebookProvider = /**
     * @private
     * @return {?}
     */
    function () {
        /** @type {?} */
        var provider = new auth.FacebookAuthProvider();
        return this.afAuth.auth.currentUser.linkWithPopup(provider);
    };
    /**
     * @private
     * @return {?}
     */
    ProvidersManagementEffects.prototype.doUnlinkToFacebookProvider = /**
     * @private
     * @return {?}
     */
    function () {
        /** @type {?} */
        var provider = new auth.FacebookAuthProvider();
        return this.afAuth.auth.currentUser.unlink(provider.providerId);
    };
    /**
     * @private
     * @return {?}
     */
    ProvidersManagementEffects.prototype.doUnlinkPhoneNumber = /**
     * @private
     * @return {?}
     */
    function () {
        /** @type {?} */
        var provider = new auth.PhoneAuthProvider();
        return this.afAuth.auth.currentUser.unlink(provider.providerId);
    };
    /**
     * @private
     * @param {?} email
     * @param {?} password
     * @return {?}
     */
    ProvidersManagementEffects.prototype.doLinkToCredentials = /**
     * @private
     * @param {?} email
     * @param {?} password
     * @return {?}
     */
    function (email, password) {
        /** @type {?} */
        var credentials = EmailAuthProvider.credential(email, password);
        return this.afAuth.auth.currentUser.linkAndRetrieveDataWithCredential(credentials);
    };
    /**
     * @private
     * @return {?}
     */
    ProvidersManagementEffects.prototype.doUnlinkToCredentials = /**
     * @private
     * @return {?}
     */
    function () {
        return this.afAuth.auth.currentUser.unlink(EmailAuthProvider.EMAIL_PASSWORD_SIGN_IN_METHOD);
    };
    /**
     * @private
     * @return {?}
     */
    ProvidersManagementEffects.prototype.doFacebookReAuthentication = /**
     * @private
     * @return {?}
     */
    function () {
        /** @type {?} */
        var provider = new auth.FacebookAuthProvider();
        return this.afAuth.auth.currentUser.reauthenticateWithPopup(provider);
    };
    /**
     * @private
     * @return {?}
     */
    ProvidersManagementEffects.prototype.doFacebookReAuthenticationWithRedirect = /**
     * @private
     * @return {?}
     */
    function () {
        /** @type {?} */
        var provider = new auth.FacebookAuthProvider();
        return this.afAuth.auth.currentUser.reauthenticateWithRedirect(provider);
    };
    /**
     * @private
     * @return {?}
     */
    ProvidersManagementEffects.prototype.reAuthenticate = /**
     * @private
     * @return {?}
     */
    function () {
        var _this = this;
        return this.afAuth.auth.fetchSignInMethodsForEmail(this.afAuth.auth.currentUser.email).then((/**
         * @param {?} res
         * @return {?}
         */
        function (res) { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!(res.indexOf('facebook.com') >= 0)) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.doFacebookReAuthentication()];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                    case 2: return [4 /*yield*/, this.doGoogleReAuthentication()];
                    case 3:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        }); }));
    };
    /**
     * @private
     * @return {?}
     */
    ProvidersManagementEffects.prototype.reAuthenticateWithRedirect = /**
     * @private
     * @return {?}
     */
    function () {
        var _this = this;
        return this.afAuth.auth.fetchSignInMethodsForEmail(this.afAuth.auth.currentUser.email).then((/**
         * @param {?} res
         * @return {?}
         */
        function (res) { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!(res.indexOf('facebook.com') >= 0)) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.doFacebookReAuthenticationWithRedirect()];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                    case 2: return [4 /*yield*/, this.doGoogleReAuthenticationWithRedirect()];
                    case 3:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        }); }));
    };
    /**
     * @private
     * @return {?}
     */
    ProvidersManagementEffects.prototype.doGoogleReAuthentication = /**
     * @private
     * @return {?}
     */
    function () {
        /** @type {?} */
        var provider = new auth.GoogleAuthProvider();
        return this.afAuth.auth.currentUser.reauthenticateWithPopup(provider);
    };
    /**
     * @private
     * @return {?}
     */
    ProvidersManagementEffects.prototype.doGoogleReAuthenticationWithRedirect = /**
     * @private
     * @return {?}
     */
    function () {
        /** @type {?} */
        var provider = new auth.GoogleAuthProvider();
        return this.afAuth.auth.currentUser.reauthenticateWithPopup(provider);
    };
    ProvidersManagementEffects.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    ProvidersManagementEffects.ctorParameters = function () { return [
        { type: Actions },
        { type: AngularFireAuth }
    ]; };
    __decorate([
        Effect(),
        __metadata("design:type", Observable)
    ], ProvidersManagementEffects.prototype, "linkToGoogleAccount$", void 0);
    __decorate([
        Effect(),
        __metadata("design:type", Observable)
    ], ProvidersManagementEffects.prototype, "linkToFacebookAccount$", void 0);
    __decorate([
        Effect(),
        __metadata("design:type", Observable)
    ], ProvidersManagementEffects.prototype, "linkToCredentialsAccount$", void 0);
    __decorate([
        Effect(),
        __metadata("design:type", Observable)
    ], ProvidersManagementEffects.prototype, "unlinkGoogleAccount$", void 0);
    __decorate([
        Effect(),
        __metadata("design:type", Observable)
    ], ProvidersManagementEffects.prototype, "unlinkFacebookAccount$", void 0);
    __decorate([
        Effect(),
        __metadata("design:type", Observable)
    ], ProvidersManagementEffects.prototype, "unlinkCredentialsAccount$", void 0);
    __decorate([
        Effect(),
        __metadata("design:type", Observable)
    ], ProvidersManagementEffects.prototype, "unlinkPhone$", void 0);
    __decorate([
        Effect(),
        __metadata("design:type", Observable)
    ], ProvidersManagementEffects.prototype, "sendCodeToPhone$", void 0);
    __decorate([
        Effect(),
        __metadata("design:type", Observable)
    ], ProvidersManagementEffects.prototype, "verifyCode$", void 0);
    return ProvidersManagementEffects;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var PasswordManagementEffects = /** @class */ (function () {
    function PasswordManagementEffects(actions$, afAuth) {
        var _this = this;
        this.actions$ = actions$;
        this.afAuth = afAuth;
        this.changePassword = this.actions$.pipe(ofType(PasswordManagementActionTypes.ChangePasswordRequest), map((/**
         * @param {?} action
         * @return {?}
         */
        function (action) { return action.payload; })), exhaustMap((/**
         * @param {?} payload
         * @return {?}
         */
        function (payload) {
            /** @type {?} */
            var credentials = auth.EmailAuthProvider.credential(_this.afAuth.auth.currentUser.email, payload.oldPassword);
            return from(_this.afAuth.auth.currentUser.reauthenticateAndRetrieveDataWithCredential(credentials).then((/**
             * @param {?} res
             * @return {?}
             */
            function (res) { return __awaiter(_this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.afAuth.auth.currentUser.updatePassword(payload.newPassword)];
                        case 1:
                            _a.sent();
                            return [2 /*return*/];
                    }
                });
            }); }))).pipe(mapTo(new ChangePasswordSuccess()), catchError((/**
             * @param {?} error
             * @return {?}
             */
            function (error) { return of(new ChangePasswordError(error)); })));
        })));
        this.passwordForgotten$ = this.actions$.pipe(ofType(PasswordManagementActionTypes.ResetPasswordRequest), map((/**
         * @param {?} action
         * @return {?}
         */
        function (action) { return action.payload; })), exhaustMap((/**
         * @param {?} payload
         * @return {?}
         */
        function (payload) {
            return from(_this.afAuth.auth.sendPasswordResetEmail(payload.email, { url: payload.redirectUrl })).pipe(map((/**
             * @param {?} authData
             * @return {?}
             */
            function (authData) {
                return new ResetPasswordRequestSuccess();
            })), catchError((/**
             * @param {?} err
             * @return {?}
             */
            function (err) { return of(new ResetPasswordRequestError(err)); })));
        })));
    }
    PasswordManagementEffects.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    PasswordManagementEffects.ctorParameters = function () { return [
        { type: Actions },
        { type: AngularFireAuth }
    ]; };
    __decorate([
        Effect(),
        __metadata("design:type", Observable)
    ], PasswordManagementEffects.prototype, "changePassword", void 0);
    __decorate([
        Effect(),
        __metadata("design:type", Object)
    ], PasswordManagementEffects.prototype, "passwordForgotten$", void 0);
    return PasswordManagementEffects;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var CustomEmailHandlerEffects = /** @class */ (function () {
    function CustomEmailHandlerEffects(actions$, afAuth) {
        var _this = this;
        this.actions$ = actions$;
        this.afAuth = afAuth;
        this.verifyEmail = this.actions$.pipe(ofType(CustomEmailHandlerActionTypes.VerifyEmailAddress), map((/**
         * @param {?} action
         * @return {?}
         */
        function (action) { return action.payload; })), switchMap((/**
         * @param {?} payload
         * @return {?}
         */
        function (payload) {
            return from(_this.afAuth.auth.applyActionCode(payload.actionCode).then((/**
             * @param {?} res
             * @return {?}
             */
            function (res) { return __awaiter(_this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/];
                });
            }); }))).pipe(mapTo(new VerifyEmailAddressSuccess()), catchError((/**
             * @param {?} error
             * @return {?}
             */
            function (error) { return of(new VerifyEmailAddressError(error)); })));
        })));
        this.verifyPasswordResetCode = this.actions$.pipe(ofType(CustomEmailHandlerActionTypes.VerifyPasswordResetCode), map((/**
         * @param {?} action
         * @return {?}
         */
        function (action) { return action.payload; })), switchMap((/**
         * @param {?} payload
         * @return {?}
         */
        function (payload) {
            return from(_this.afAuth.auth.verifyPasswordResetCode(payload.actionCode)).pipe(switchMap((/**
             * @param {?} email
             * @return {?}
             */
            function (email) {
                return of(new VerifyPasswordResetCodeSuccess({ email: email, actionCode: payload.actionCode }));
            })), catchError((/**
             * @param {?} error
             * @return {?}
             */
            function (error) { return of(new VerifyPasswordResetCodeError(error)); })));
        })));
        this.resetPassword = this.actions$.pipe(ofType(CustomEmailHandlerActionTypes.ResetPassword), map((/**
         * @param {?} action
         * @return {?}
         */
        function (action) { return action.payload; })), switchMap((/**
         * @param {?} payload
         * @return {?}
         */
        function (payload) {
            return from(_this.afAuth.auth.confirmPasswordReset(payload.actionCode, payload.newPassword)).pipe(switchMap((/**
             * @return {?}
             */
            function () {
                return of(new ResetPasswordSuccess());
            })), catchError((/**
             * @param {?} error
             * @return {?}
             */
            function (error) { return of(new ResetPasswordError(error)); })));
        })));
        this.checkActionCode = this.actions$.pipe(ofType(CustomEmailHandlerActionTypes.CheckActionCode), map((/**
         * @param {?} action
         * @return {?}
         */
        function (action) { return action.payload; })), switchMap((/**
         * @param {?} payload
         * @return {?}
         */
        function (payload) {
            return from(_this.afAuth.auth.checkActionCode(payload.actionCode)).pipe(map((/**
             * @param {?} info
             * @return {?}
             */
            function (info) { return info['data']['email']; })), switchMap((/**
             * @param {?} restoredEmail
             * @return {?}
             */
            function (restoredEmail) {
                return of(new CheckActionCodeSuccess({ actionCode: payload.actionCode, restoredEmail: restoredEmail }));
            })), catchError((/**
             * @param {?} error
             * @return {?}
             */
            function (error) { return of(new CheckActionCodeError(error)); })));
        })));
        this.revertOldEmail = this.actions$.pipe(ofType(CustomEmailHandlerActionTypes.RecoverEmail), map((/**
         * @param {?} action
         * @return {?}
         */
        function (action) { return action.payload; })), switchMap((/**
         * @param {?} payload
         * @return {?}
         */
        function (payload) {
            return from(_this.afAuth.auth.applyActionCode(payload.actionCode)).pipe(switchMap((/**
             * @return {?}
             */
            function () {
                return of(new RecoverEmailSuccess());
            })), catchError((/**
             * @param {?} error
             * @return {?}
             */
            function (error) { return of(new RecoverEmailError(error)); })));
        })));
    }
    CustomEmailHandlerEffects.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    CustomEmailHandlerEffects.ctorParameters = function () { return [
        { type: Actions },
        { type: AngularFireAuth }
    ]; };
    __decorate([
        Effect(),
        __metadata("design:type", Observable)
    ], CustomEmailHandlerEffects.prototype, "verifyEmail", void 0);
    __decorate([
        Effect(),
        __metadata("design:type", Observable)
    ], CustomEmailHandlerEffects.prototype, "verifyPasswordResetCode", void 0);
    __decorate([
        Effect(),
        __metadata("design:type", Observable)
    ], CustomEmailHandlerEffects.prototype, "resetPassword", void 0);
    __decorate([
        Effect(),
        __metadata("design:type", Observable)
    ], CustomEmailHandlerEffects.prototype, "checkActionCode", void 0);
    __decorate([
        Effect(),
        __metadata("design:type", Observable)
    ], CustomEmailHandlerEffects.prototype, "revertOldEmail", void 0);
    return CustomEmailHandlerEffects;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var FirebaseNgrxUserManagementModule = /** @class */ (function () {
    function FirebaseNgrxUserManagementModule() {
    }
    FirebaseNgrxUserManagementModule.decorators = [
        { type: NgModule, args: [{
                    imports: [
                        AngularFireModule,
                        AngularFireAuthModule,
                        EffectsModule.forFeature([
                            CustomEmailHandlerEffects,
                            LoginEffects,
                            ReAuthenticationEffects,
                            RegistrationEffects,
                            ProvidersManagementEffects,
                            PasswordManagementEffects
                        ]),
                        StoreModule.forFeature('auth', reducers)
                    ],
                    declarations: [],
                    exports: [],
                    providers: []
                },] }
    ];
    return FirebaseNgrxUserManagementModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { User, getAuthState, isAuthLoading, passwordManagement_actions as PasswordManagementActions, providersManagement_actions as ProvidersManagementActions, getChangePasswordStatus, isUserLogged, getUser, getAuthError, isAuthSuccess, getUserState, getUserProvidersState, getUserProviders, getProvidersRequestStatus, getCustomEmailHandlerRequestStatus, isEmailVerifiedLoading, getEmailVerifiedError, isRecoverEmailLoading, isResetPasswordLoading, isPasswordResetCodeLoading, isCheckCodeLoading, getPasswordResetCodeError, getRecoverEmailError, getCheckCodeError, getResetPasswordError, isResetPasswordOrCodeLoading, getResetPasswordOrCodeError, getRecoverEmailOrCheckCodeError, isRecoverEmailOrCheckCodeLoading, getPasswordResetCodeEmail, getResetPasswordSuccess, auth_actions as AuthActions, customEmailHandler_actions as CustomEmailHandlerActions, getEmailVerifiedStatus, getVerifyResetPasswordProcedure, getPasswordResetStatus, FirebaseNgrxUserManagementService, FirebaseNgrxUserManagementModule, CustomEmailHandlerEffects as ɵd, LoginEffects as ɵe, PasswordManagementEffects as ɵi, ProvidersManagementEffects as ɵh, ReAuthenticationEffects as ɵf, RegistrationEffects as ɵg, reducer$3 as ɵk, reducers as ɵa, reducer$1 as ɵj, reducer$2 as ɵc, reducer as ɵb };

//# sourceMappingURL=xtream-firebase-ngrx-user-management.js.map