import { Action } from '@ngrx/store';
export declare enum CustomEmailHandlerActionTypes {
    CheckActionCode = "[Auth/CustomEmailHandler] Check Action Code",
    CheckActionCodeError = "[Auth/CustomEmailHandler] Check Action Code Error",
    CheckActionCodeSuccess = "[Auth/CustomEmailHandler] Check Action Code Success",
    RecoverEmail = "[Auth/CustomEmailHandler] Recover Email",
    RecoverEmailSuccess = "[Auth/CustomEmailHandler] Recover Email Success",
    RecoverEmailError = "[Auth/CustomEmailHandler] Recover Email Error",
    ResetPassword = "[Auth/CustomEmailHandler] Reset Password",
    ResetPasswordSuccess = "[Auth/CustomEmailHandler] Reset Password Success",
    ResetPasswordError = "[Auth/CustomEmailHandler] Reset Password Error",
    VerifyEmailAddress = "[Auth/CustomEmailHandler] Verify Email Address",
    VerifyEmailAddressSuccess = "[Auth/CustomEmailHandler] Verify Email Address Success",
    VerifyEmailAddressError = "[Auth/CustomEmailHandler] Verify Email Address Error",
    VerifyPasswordResetCode = "[Auth/CustomEmailHandler] Verify Password Reset Code",
    VerifyPasswordResetCodeError = "[Auth/CustomEmailHandler] Verify Password Reset Error",
    VerifyPasswordResetCodeSuccess = "[Auth/CustomEmailHandler] Verify Password Reset Success"
}
export declare class CheckActionCode implements Action {
    payload: {
        actionCode: string;
    };
    readonly type = CustomEmailHandlerActionTypes.CheckActionCode;
    constructor(payload: {
        actionCode: string;
    });
}
export declare class CheckActionCodeError implements Action {
    payload: {
        code: string;
        message: string;
    };
    readonly type = CustomEmailHandlerActionTypes.CheckActionCodeError;
    constructor(payload: {
        code: string;
        message: string;
    });
}
export declare class CheckActionCodeSuccess implements Action {
    payload: {
        actionCode: string;
        restoredEmail: string;
    };
    readonly type = CustomEmailHandlerActionTypes.CheckActionCodeSuccess;
    constructor(payload: {
        actionCode: string;
        restoredEmail: string;
    });
}
export declare class RecoverEmail implements Action {
    payload: {
        actionCode: string;
    };
    readonly type = CustomEmailHandlerActionTypes.RecoverEmail;
    constructor(payload: {
        actionCode: string;
    });
}
export declare class RecoverEmailError implements Action {
    payload: {
        code: string;
        message: string;
    };
    readonly type = CustomEmailHandlerActionTypes.RecoverEmailError;
    constructor(payload: {
        code: string;
        message: string;
    });
}
export declare class RecoverEmailSuccess implements Action {
    readonly type = CustomEmailHandlerActionTypes.RecoverEmailSuccess;
}
export declare class ResetPassword implements Action {
    payload: {
        actionCode: string;
        newPassword: string;
    };
    readonly type = CustomEmailHandlerActionTypes.ResetPassword;
    constructor(payload: {
        actionCode: string;
        newPassword: string;
    });
}
export declare class ResetPasswordError implements Action {
    payload: {
        code: string;
        message: string;
    };
    readonly type = CustomEmailHandlerActionTypes.ResetPasswordError;
    constructor(payload: {
        code: string;
        message: string;
    });
}
export declare class ResetPasswordSuccess implements Action {
    readonly type = CustomEmailHandlerActionTypes.ResetPasswordSuccess;
}
export declare class VerifyEmailAddress implements Action {
    payload: {
        actionCode: string;
    };
    readonly type = CustomEmailHandlerActionTypes.VerifyEmailAddress;
    constructor(payload: {
        actionCode: string;
    });
}
export declare class VerifyEmailAddressError implements Action {
    payload: {
        code: string;
        message: string;
    };
    readonly type = CustomEmailHandlerActionTypes.VerifyEmailAddressError;
    constructor(payload: {
        code: string;
        message: string;
    });
}
export declare class VerifyEmailAddressSuccess implements Action {
    readonly type = CustomEmailHandlerActionTypes.VerifyEmailAddressSuccess;
}
export declare class VerifyPasswordResetCode implements Action {
    payload: {
        actionCode: string;
    };
    readonly type = CustomEmailHandlerActionTypes.VerifyPasswordResetCode;
    constructor(payload: {
        actionCode: string;
    });
}
export declare class VerifyPasswordResetCodeError implements Action {
    payload: {
        code: string;
        message: string;
    };
    readonly type = CustomEmailHandlerActionTypes.VerifyPasswordResetCodeError;
    constructor(payload: {
        code: string;
        message: string;
    });
}
export declare class VerifyPasswordResetCodeSuccess implements Action {
    payload: {
        email: string;
        actionCode: string;
    };
    readonly type = CustomEmailHandlerActionTypes.VerifyPasswordResetCodeSuccess;
    constructor(payload: {
        email: string;
        actionCode: string;
    });
}
export declare type CustomEmailHandlerActionsUnion = CheckActionCode | CheckActionCodeError | CheckActionCodeSuccess | RecoverEmail | RecoverEmailSuccess | RecoverEmailError | ResetPassword | ResetPasswordSuccess | ResetPasswordError | VerifyEmailAddress | VerifyEmailAddressError | VerifyEmailAddressSuccess | VerifyPasswordResetCode | VerifyPasswordResetCodeError | VerifyPasswordResetCodeSuccess;
