import { Action } from '@ngrx/store';
export declare enum PasswordManagementActionTypes {
    ChangePasswordRequest = "[Auth/Password] Change Password Request",
    ChangePasswordError = "[Auth/Password] Change Password Error",
    ChangePasswordSuccess = "[Auth/Password] Change Password Success",
    ResetPasswordStatus = "[Auth/Password] Reset Change Password Status",
    ResetPasswordRequest = "[Auth/Password] Reset Password Request",
    ResetPasswordRequestError = "[Auth/Password] Reset Password Request Error",
    ResetPasswordRequestSuccess = "[Auth/Password] Reset Password Request Success"
}
export declare class ChangePasswordRequest implements Action {
    payload: {
        oldPassword: string;
        newPassword: string;
    };
    readonly type = PasswordManagementActionTypes.ChangePasswordRequest;
    constructor(payload: {
        oldPassword: string;
        newPassword: string;
    });
}
export declare class ChangePasswordError implements Action {
    payload: {
        code: string;
        message: string;
    };
    readonly type = PasswordManagementActionTypes.ChangePasswordError;
    constructor(payload: {
        code: string;
        message: string;
    });
}
export declare class ChangePasswordSuccess implements Action {
    readonly type = PasswordManagementActionTypes.ChangePasswordSuccess;
}
export declare class ResetPasswordStatus implements Action {
    readonly type = PasswordManagementActionTypes.ResetPasswordStatus;
}
export declare class ResetPasswordRequest implements Action {
    payload: {
        email: string;
        redirectUrl: string;
    };
    readonly type = PasswordManagementActionTypes.ResetPasswordRequest;
    constructor(payload: {
        email: string;
        redirectUrl: string;
    });
}
export declare class ResetPasswordRequestError implements Action {
    payload: {
        code: string;
        message: string;
    };
    readonly type = PasswordManagementActionTypes.ResetPasswordRequestError;
    constructor(payload: {
        code: string;
        message: string;
    });
}
export declare class ResetPasswordRequestSuccess implements Action {
    readonly type = PasswordManagementActionTypes.ResetPasswordRequestSuccess;
}
export declare type PasswordManagementActionsUnion = ChangePasswordRequest | ChangePasswordError | ChangePasswordSuccess | ResetPasswordStatus | ResetPasswordRequest | ResetPasswordRequestSuccess | ResetPasswordRequestError;
