import { Action } from '@ngrx/store';
export declare enum ProvidersManagementActionTypes {
    CodeSent = "[Auth/Providers] Code Sent",
    LinkCredentialAccount = "[Auth/Providers] Link Credential Account",
    LinkFacebookAccount = "[Auth/Providers] Link Facebook Account",
    LinkGoogleAccount = "[Auth/Providers] Link Google Account",
    LinkError = "[Auth/Providers] Link Error",
    LinkSuccess = "[Auth/Providers] Link Success",
    SetProviders = "[Auth/Providers] Set Providers",
    UnlinkCredentialAccount = "[Auth/Providers] Unlink Credential Account",
    UnlinkFacebookAccount = "[Auth/Providers] Unlink Facebook Account",
    UnlinkGoogleAccount = "[Auth/Providers] Unlink Google Account",
    UnlinkError = "[Auth/Providers] Unlink Error",
    UnlinkSuccess = "[Auth/Providers] Unlink Success",
    SendPhoneNumberCode = "[Auth] Send Phone Number Code",
    UnlinkPhoneNumber = "[Auth] Unlink Phone Number",
    VerifyPhoneNumber = "[Auth] Verify Phone"
}
export declare class LinkCredentialAccount implements Action {
    payload: {
        password: string;
    };
    readonly type = ProvidersManagementActionTypes.LinkCredentialAccount;
    constructor(payload: {
        password: string;
    });
}
export declare class LinkFacebookAccount implements Action {
    readonly type = ProvidersManagementActionTypes.LinkFacebookAccount;
    constructor();
}
export declare class LinkGoogleAccount implements Action {
    readonly type = ProvidersManagementActionTypes.LinkGoogleAccount;
    constructor();
}
export declare class VerifyPhoneNumber implements Action {
    payload: {
        code: string;
    };
    readonly type = ProvidersManagementActionTypes.VerifyPhoneNumber;
    constructor(payload: {
        code: string;
    });
}
export declare class LinkSuccess implements Action {
    payload: {
        provider: string;
    };
    readonly type = ProvidersManagementActionTypes.LinkSuccess;
    constructor(payload: {
        provider: string;
    });
}
export declare class LinkError implements Action {
    payload: {
        code: string;
        message: string;
    };
    readonly type = ProvidersManagementActionTypes.LinkError;
    constructor(payload: {
        code: string;
        message: string;
    });
}
export declare class UnlinkSuccess implements Action {
    payload: {
        provider: string;
    };
    readonly type = ProvidersManagementActionTypes.UnlinkSuccess;
    constructor(payload: {
        provider: string;
    });
}
export declare class UnlinkError implements Action {
    payload: {
        code: string;
        message: string;
    };
    readonly type = ProvidersManagementActionTypes.UnlinkError;
    constructor(payload: {
        code: string;
        message: string;
    });
}
export declare class SendPhoneNumberCode implements Action {
    payload: {
        number: string;
        captchaContainerId: string;
    };
    readonly type = ProvidersManagementActionTypes.SendPhoneNumberCode;
    constructor(payload: {
        number: string;
        captchaContainerId: string;
    });
}
export declare class UnlinkFacebookAccount implements Action {
    readonly type = ProvidersManagementActionTypes.UnlinkFacebookAccount;
    constructor();
}
export declare class UnlinkGoogleAccount implements Action {
    readonly type = ProvidersManagementActionTypes.UnlinkGoogleAccount;
    constructor();
}
export declare class UnlinkCredentialAccount implements Action {
    readonly type = ProvidersManagementActionTypes.UnlinkCredentialAccount;
    constructor();
}
export declare class SetProviders implements Action {
    payload: Partial<{
        facebook: boolean;
        google: boolean;
        phone: boolean;
        password: boolean;
    }>;
    readonly type = ProvidersManagementActionTypes.SetProviders;
    constructor(payload: Partial<{
        facebook: boolean;
        google: boolean;
        phone: boolean;
        password: boolean;
    }>);
}
export declare class CodeSent implements Action {
    readonly type = ProvidersManagementActionTypes.CodeSent;
}
export declare class UnlinkPhoneNumber implements Action {
    readonly type = ProvidersManagementActionTypes.UnlinkPhoneNumber;
}
export declare type ProvidersManagementActionsUnion = LinkCredentialAccount | LinkFacebookAccount | LinkGoogleAccount | VerifyPhoneNumber | LinkError | LinkSuccess | UnlinkSuccess | UnlinkFacebookAccount | UnlinkGoogleAccount | UnlinkError | UnlinkCredentialAccount | SendPhoneNumberCode | SetProviders | CodeSent;
