import { Actions } from '@ngrx/effects';
import { Observable } from 'rxjs';
import { Action } from '@ngrx/store';
import { AngularFireAuth } from '@angular/fire/auth';
import 'firebase/auth';
import { Facebook } from '@ionic-native/facebook/ngx';
import { GooglePlus } from '@ionic-native/google-plus/ngx';
import { FirebaseUserManagementConfig } from '../config';
export declare class ProvidersManagementEffects {
    private actions$;
    private fb;
    private gplus;
    private afAuth;
    private config;
    linkToGoogleAccount$: Observable<Action>;
    linkToFacebookAccount$: Observable<Action>;
    linkToCredentialsAccount$: Observable<Action>;
    unlinkGoogleAccount$: Observable<Action>;
    unlinkFacebookAccount$: Observable<Action>;
    unlinkCredentialsAccount$: Observable<Action>;
    unlinkPhone$: Observable<Action>;
    sendCodeToPhone$: Observable<Action>;
    verifyCode$: Observable<Action>;
    private phoneNumberConfirmation;
    private doLinkToGoogleProvider;
    private doUnlinkToGoogleProvider;
    private doLinkToFacebookProvider;
    private doUnlinkToFacebookProvider;
    private doUnlinkPhoneNumber;
    private doLinkToCredentials;
    private doUnlinkToCredentials;
    private doFacebookReAuthentication;
    private doFacebookReAuthenticationWithRedirect;
    private reAuthenticate;
    private reAuthenticateWithRedirect;
    private doGoogleReAuthentication;
    private doGoogleReAuthenticationWithRedirect;
    constructor(actions$: Actions, fb: Facebook, gplus: GooglePlus, afAuth: AngularFireAuth, config: FirebaseUserManagementConfig);
}
