import { Actions } from '@ngrx/effects';
import { AngularFireAuth } from '@angular/fire/auth';
import { AuthActions } from '../actions';
import { Observable } from 'rxjs';
import 'firebase/auth';
import { ProvidersManagementActionsUnion } from '../actions/providers-management.actions';
import { Facebook } from '@ionic-native/facebook/ngx';
import { GooglePlus } from '@ionic-native/google-plus/ngx';
import { Platform } from '@ionic/angular';
import { FirebaseUserManagementConfig } from '../config';
export declare type Action = AuthActions.AuthActionsUnion | ProvidersManagementActionsUnion;
export declare class RegistrationEffects {
    private actions;
    private fb;
    private gplus;
    private platform;
    private afAuth;
    private config;
    constructor(actions: Actions, fb: Facebook, gplus: GooglePlus, platform: Platform, afAuth: AngularFireAuth, config: FirebaseUserManagementConfig);
    googleSignUp: Observable<Action>;
    facebookSignUp: Observable<Action>;
    signUpWithCredentials: Observable<Action>;
    sendVerificationEmail$: Observable<Action>;
    private doFacebookLogin;
    private doFacebookLoginMobile;
    private doGoogleLogin;
    private doGoogleLoginMobile;
    private doSignUpWithCredentials;
}
