import * as fromUser from './user.reducer';
import * as fromChangePassword from './password-management.reducer';
import * as fromProviders from './providers-management.reducer';
import * as fromCustomEmailHandler from './custom-email-handler.reducer';
import { ActionReducerMap, MemoizedSelector } from '@ngrx/store';
export interface AuthState {
    user: fromUser.State;
    changePassword: fromChangePassword.State;
    providers: fromProviders.State;
    customEmailHandler: fromCustomEmailHandler.State;
}
export declare const reducers: ActionReducerMap<AuthState>;
export declare const getAuthState: MemoizedSelector<object, AuthState>;
export declare const getUserState: MemoizedSelector<object, fromUser.State>;
export declare const isAuthLoading: MemoizedSelector<object, boolean>;
export declare const isUserLogged: MemoizedSelector<object, boolean>;
export declare const getUser: MemoizedSelector<object, import("../models/auth.model").User>;
export declare const getAuthError: MemoizedSelector<object, {
    code: string;
    message: string;
}>;
export declare const isAuthSuccess: MemoizedSelector<object, boolean>;
export declare const getChangePasswordStatus: MemoizedSelector<object, fromChangePassword.State>;
export declare const getUserProvidersState: MemoizedSelector<object, fromProviders.State>;
export declare const getUserProviders: MemoizedSelector<object, {
    facebook: boolean;
    google: boolean;
    phone: boolean;
    password: boolean;
}>;
export declare const getProvidersRequestStatus: MemoizedSelector<object, {
    loading: boolean;
    error: {
        code: string;
        message: string;
    };
    success: boolean;
}>;
export declare const getCustomEmailHandlerRequestStatus: MemoizedSelector<object, {
    emailVerified: {
        loading: boolean;
        error: {
            code: string;
            message: string;
        };
        success: boolean;
    };
}>;
export declare const getEmailVerifiedStatus: MemoizedSelector<object, {
    loading: boolean;
    success: boolean;
    error: {
        code: string;
        message: string;
    };
}>;
export declare const getPasswordResetStatus: MemoizedSelector<object, {
    loading: boolean;
    success: boolean;
    error: {
        code: string;
        message: string;
    };
}>;
export declare const getVerifyResetPasswordProcedure: MemoizedSelector<object, {
    email: string;
    loading: boolean;
    success: boolean;
    error: {
        code: string;
        message: string;
    };
}>;
export declare const getEmailVerifiedError: MemoizedSelector<object, {
    code: string;
    message: string;
}>;
export declare const isEmailVerifiedLoading: MemoizedSelector<object, boolean>;
export declare const getPasswordResetCodeError: MemoizedSelector<object, {
    code: string;
    message: string;
}>;
export declare const isPasswordResetCodeLoading: MemoizedSelector<object, boolean>;
export declare const getPasswordResetCodeEmail: MemoizedSelector<object, string>;
export declare const getResetPasswordError: MemoizedSelector<object, {
    code: string;
    message: string;
}>;
export declare const isResetPasswordLoading: MemoizedSelector<object, boolean>;
export declare const getCheckCodeError: MemoizedSelector<object, {
    code: string;
    message: string;
}>;
export declare const isCheckCodeLoading: MemoizedSelector<object, boolean>;
export declare const getRecoverEmailError: MemoizedSelector<object, {
    code: string;
    message: string;
}>;
export declare const isRecoverEmailLoading: MemoizedSelector<object, boolean>;
export declare const getResetPasswordOrCodeError: MemoizedSelector<object, {
    code: string;
    message: string;
}>;
export declare const getResetPasswordSuccess: MemoizedSelector<object, boolean>;
export declare const isResetPasswordOrCodeLoading: MemoizedSelector<object, boolean>;
export declare const getRecoverEmailOrCheckCodeError: MemoizedSelector<object, {
    code: string;
    message: string;
}>;
export declare const isRecoverEmailOrCheckCodeLoading: MemoizedSelector<object, boolean>;
